// PPgGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgGeneral.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgGeneral dialog
//CBarShader CPPgGeneral::s_preview(16,16); 

IMPLEMENT_DYNAMIC(CPPgGeneral, CPropertyPage)
CPPgGeneral::CPPgGeneral()
	: CPropertyPage(CPPgGeneral::IDD)
	, beepOnErrors(FALSE)
	, showSplashscreen(FALSE)
	, allowMultipleInstances(FALSE)
	, onlineSignature(FALSE)
	, writeLogToFile(FALSE)
	, debugLog(FALSE)
	, doubleClickClientDetails(FALSE)
	, userNick(_T(""))
	, tooltipDelay(_T(""))	
	, mainProcess(0)
{
}

CPPgGeneral::~CPPgGeneral()
{
}

void CPPgGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LANGS, languageCombo);
	DDX_Control(pDX, IDC_PREVIEW, m_3DPreview);
	DDX_Control(pDX, IDC_3DDEPTH, threeDSlider);
	DDX_Control(pDX, IDC_NICK, userNickEdit);
	DDX_Control(pDX, IDC_BEEPER, beepOnErrorsCheck);
	DDX_Control(pDX, IDC_SPLASHON, showSplashscreenCheck);
	DDX_Control(pDX, IDC_MULTIPLE, allowMultipleInstancesCheck);
	DDX_Control(pDX, IDC_ONLINESIG, onlineSignatureCheck);
	DDX_Control(pDX, IDC_LOGTOFILE, writeLogToFileCheck);
	DDX_Control(pDX, IDC_VERBOSE, debugLogCheck);
	DDX_Control(pDX, IDC_DC_CLIENT, doubleClickClientDetailsCheck);
	DDX_Check(pDX, IDC_BEEPER, beepOnErrors);
	DDX_Check(pDX, IDC_SPLASHON, showSplashscreen);
	DDX_Check(pDX, IDC_MULTIPLE, allowMultipleInstances);
	DDX_Check(pDX, IDC_ONLINESIG, onlineSignature);
	DDX_Check(pDX, IDC_LOGTOFILE, writeLogToFile);
	DDX_Check(pDX, IDC_VERBOSE, debugLog);
	DDX_Check(pDX, IDC_DC_CLIENT, doubleClickClientDetails);
	DDX_Text(pDX, IDC_TOOLTIPDELAY, tooltipDelay);	
	DDX_Text(pDX, IDC_NICK, userNick);
	DDX_Control(pDX, IDC_NICK_FRM, nickDesc);
	DDX_Control(pDX, IDC_LANG_FRM, languageDesc);
	DDX_Control(pDX, IDC_MISC_FRM, miscDesc);
	DDX_Control(pDX, IDC_TOOLTIPDELAY_LBL, tooltipDelayDesc);
	DDX_Control(pDX, IDC_3DDEP, threeDDepDesc);
	DDX_Radio(pDX, IDC_MP_STANDARD, mainProcess);
	DDX_Control(pDX, IDC_MP_STANDARD, standardProcessRadio);
	DDX_Control(pDX, IDC_MP_HIGH, highProcessRadio);
	DDX_Control(pDX, IDC_MAINPROCESS, mainProcessDesc);
	DDX_Control(pDX, IDC_WEBSVEDIT, webSvEditButton);
}

BEGIN_MESSAGE_MAP(CPPgGeneral, CPropertyPage)
	ON_EN_CHANGE(IDC_NICK, OnSettingsChange)
	ON_EN_CHANGE(IDC_TOOLTIPDELAY, OnSettingsChange)
	ON_CBN_SELCHANGE(IDC_LANGS, OnSettingsChange)
	ON_BN_CLICKED(IDC_BEEPER, OnSettingsChange)
	ON_BN_CLICKED(IDC_SPLASHON, OnSettingsChange)
	ON_BN_CLICKED(IDC_NOTIFY, OnSettingsChange)
	ON_BN_CLICKED(IDC_ONLINESIG, OnSettingsChange)
	ON_BN_CLICKED(IDC_LOGTOFILE, OnSettingsChange)
	ON_BN_CLICKED(IDC_MULTIPLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_DC_CLIENT, OnSettingsChange)
	ON_BN_CLICKED(IDC_VERBOSE, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_STANDARD, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_HIGH, OnSettingsChange)
	ON_BN_CLICKED(IDC_WEBSVEDIT , OnBnClickedEditWebservices)
	ON_WM_HSCROLL()
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_3DDEPTH, On3DDepth)
END_MESSAGE_MAP()

BOOL CPPgGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	userNickEdit.SetLimitText(49);
	
	LoadSettings();
	DrawPreview();
	Localize();

	return TRUE;
}

void CPPgGeneral::LoadLanguagesCombo(void)
{
	static const WORD wLangs[] = 
	{
		MAKELANGID(LANG_CATALAN,SUBLANG_DEFAULT),  // Catalonian
		MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_SIMPLIFIED), // Chinese (simplified)
		MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_TRADITIONAL), // Chinese (traditional)
		MAKELANGID(LANG_DANISH,SUBLANG_DEFAULT),  // Danish
		MAKELANGID(LANG_DUTCH,SUBLANG_DEFAULT),  // Dutch
		MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT),  // English
		MAKELANGID(LANG_FINNISH,SUBLANG_DEFAULT),  // Finnish
		MAKELANGID(LANG_FRENCH,SUBLANG_DEFAULT),  // French
		MAKELANGID(LANG_GERMAN,SUBLANG_DEFAULT),  // German
		MAKELANGID(LANG_GREEK,SUBLANG_DEFAULT),  // Greek
		MAKELANGID(LANG_HEBREW,SUBLANG_DEFAULT),  // Hebrew
		MAKELANGID(LANG_ITALIAN,SUBLANG_DEFAULT),  // Italian
		MAKELANGID(LANG_KOREAN,SUBLANG_DEFAULT),  // Korean
		MAKELANGID(LANG_POLISH,SUBLANG_DEFAULT),  // Polish
		MAKELANGID(LANG_PORTUGUESE,SUBLANG_PORTUGUESE),  //Portuguese (Portugal)
		MAKELANGID(LANG_PORTUGUESE,SUBLANG_PORTUGUESE_BRAZILIAN), // Portuguese (Brasilian)
		MAKELANGID(LANG_RUSSIAN,SUBLANG_DEFAULT),  // Russian
		MAKELANGID(LANG_SPANISH,SUBLANG_SPANISH),  // Spanish
		MAKELANGID(LANG_LITHUANIAN,SUBLANG_DEFAULT),  // Lithuanian
		MAKELANGID(LANG_ROMANIAN,SUBLANG_DEFAULT),  // Romanian
		MAKELANGID(LANG_BASQUE,SUBLANG_DEFAULT),  // Basque
		MAKELANGID(LANG_TURKISH,SUBLANG_DEFAULT)  // Turkish
	};
	
	CString szLang;	
	for(int i = 0; i < sizeof(wLangs) / sizeof(WORD); i++) 
	{
		GetLocaleInfo(wLangs[i], LOCALE_SLANGUAGE, szLang.GetBuffer(128), 128);
		szLang.ReleaseBuffer();
		switch(PRIMARYLANGID(wLangs[i]))			//Cax2 no sublangs in brackets for the following languages
		{
			case	LANG_ENGLISH:
			case 	LANG_GERMAN:
			case 	LANG_FRENCH:
			case 	LANG_SPANISH:
			case 	LANG_DUTCH:
			case	LANG_ITALIAN:
			{	
				int iBracket = szLang.Find('(');
				if(iBracket > 0)
					szLang.Delete(iBracket, szLang.GetLength() - iBracket);
				break;
			}
		}
		languageCombo.SetItemData(languageCombo.AddString(szLang), wLangs[i]);
	}
}

void CPPgGeneral::LoadSettings(void)
{
	userNick = app_prefs->GetUserNick();

	LoadLanguagesCombo();
	for(int i = 0; i != languageCombo.GetCount(); i++)
	{
		if(languageCombo.GetItemData(i) == app_prefs->GetLanguageID())
		{
			languageCombo.SetCurSel(i);
			break;
		}
	}
		
	beepOnErrors = app_prefs->IsErrorBeepEnabled();
	showSplashscreen = app_prefs->UseSplashScreen();
	allowMultipleInstances = app_prefs->GetMultiple();
	onlineSignature = app_prefs->IsOnlineSignatureEnabled();
	writeLogToFile = app_prefs->LogToFile();
	debugLog = app_prefs->GetVerbose();
	doubleClickClientDetails = app_prefs->GetDetailsOnClick();

	switch(app_prefs->GetMainProcessPriority())
	{
		case 0:
			mainProcess = 0;
			break;
		case 1:
			mainProcess = 1;
			break;
		default:
			mainProcess = 1;
			break;
	}

	tooltipDelay.Format(_T("%d"), app_prefs->GetToolTipDelay());	

	threeDSlider.SetRange(-5, 5, true);
	int tmp = app_prefs->Get3DDepth();
	if (tmp > 10)
		tmp = tmp - 256;
	threeDSlider.SetPos(tmp);

	UpdateData(FALSE);

	SetModified(FALSE);
}

BOOL CPPgGeneral::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);
					
		if (!userNick.IsEmpty())
			app_prefs->SetUserNick(userNick);
	
		int cs = languageCombo.GetCurSel();
		if (cs != CB_ERR)
		{
			WORD byNewLang = languageCombo.GetItemData(cs);
			if (app_prefs->GetLanguageID() != byNewLang)
			{
				app_prefs->SetLanguageID( byNewLang);
				if (theApp.glob_prefs->IsNTBased())
				{
					SetThreadLocale(byNewLang);
				}
				theApp.emuledlg->preferenceswnd.Localize();
				theApp.emuledlg->statisticswnd.Localize();
				theApp.emuledlg->serverwnd.Localize();
				theApp.emuledlg->transferwnd.Localize();
				theApp.emuledlg->searchwnd.Localize();
				theApp.emuledlg->sharedfileswnd.Localize();
				theApp.emuledlg->chatwnd.Localize();
				theApp.emuledlg->Localize();
				theApp.emuledlg->ircwnd.Localize();
				theApp.emuledlg->transferwnd.EditCatTabLabel(0, GetCatTitle(theApp.glob_prefs->GetAllcatType()));
			}
		}
		
		app_prefs->SetErrorBeepEnabled(beepOnErrors);
		app_prefs->SetUseSplashScreen(showSplashscreen);
		app_prefs->SetOnlineSignatureEnabled(onlineSignature);
		app_prefs->SetLogToFile(writeLogToFile);
		app_prefs->SetDetailsOnClick(doubleClickClientDetails);
		app_prefs->SetMultiple(allowMultipleInstances);
		app_prefs->Set3DDepth(((CSliderCtrl*)GetDlgItem(IDC_3DDEPTH))->GetPos());
		if (app_prefs->GetVerbose() != (bool)debugLog)
		{
			app_prefs->SetVerbose(debugLog);
			theApp.emuledlg->serverwnd.ToggleDebugWindow();
			if(debugLog)
				AddDebugLogLine(false,_T("Debug log is active"));
		}	
		
		int td = _tstoi(tooltipDelay);
		if(td > 60)
			td = 60;
		app_prefs->SetToolTipDelay(td);

		theApp.emuledlg->transferwnd.m_ttip.SetDelayTime(TTDT_INITIAL, theApp.glob_prefs->GetToolTipDelay()*1000+25); // DonGato: 25 reduce flickering
		
		if(mainProcess == 0)		
			app_prefs->SetMainProcessPriority(0);
		else
			app_prefs->SetMainProcessPriority(1);
		
		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgGeneral::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_GENERAL));
		nickDesc.SetWindowText(GetResString(IDS_PW_NICK));
		languageDesc.SetWindowText(GetResString(IDS_PW_LANG));
		miscDesc.SetWindowText(GetResString(IDS_PW_MISC));
		beepOnErrorsCheck.SetWindowText(GetResString(IDS_PW_BEEP));
		showSplashscreenCheck.SetWindowText(GetResString(IDS_PW_SPLASH));
		tooltipDelayDesc.SetWindowText(GetResString(IDS_PW_TOOL));
		onlineSignatureCheck.SetWindowText(GetResString(IDS_PREF_ONLINESIG));	
		writeLogToFileCheck.SetWindowText(GetResString(IDS_LOGTOFILE));
		allowMultipleInstancesCheck.SetWindowText(GetResString(IDS_MULTIPLE));
		doubleClickClientDetailsCheck.SetWindowText(GetResString(IDS_DC_CLIENT));
		threeDDepDesc.SetWindowText(GetResString(IDS_3DDEP));
		debugLogCheck.SetWindowText(GetResString(IDS_VERBOSE));
		mainProcessDesc.SetWindowText(GetResString(IDS_MAINPROCESS_LBL));
		standardProcessRadio.SetWindowText(GetResString(IDS_HASHPRIO_STANDARD));
		highProcessRadio.SetWindowText(GetResString(IDS_PRIOHIGH));
		webSvEditButton.SetWindowText(GetResString(IDS_WEBSVEDIT));
	}
}

void CPPgGeneral::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	UpdateData(false); 
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}
void CPPgGeneral::OnPaint()
{
	CPropertyPage::OnPaint();
	DrawPreview();
}

void CPPgGeneral::DrawPreview()
{
	m_3DPreview.SetSliderPos(threeDSlider.GetPos());
}

void CPPgGeneral::On3DDepth(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	DrawPreview();
	*pResult = 0;
}

void CPPgGeneral::OnBnClickedEditWebservices()
{
	ShellExecute(NULL, _T("open"), theApp.glob_prefs->GetTxtEditor(), _T("\"")+CString(theApp.glob_prefs->GetConfigDir())+_T("webservices.dat\""), NULL, SW_SHOW); 
}
