// PPgIRC.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgIRC.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgIRC dialog

IMPLEMENT_DYNAMIC(CPPgIRC, CPropertyPage)
CPPgIRC::CPPgIRC()
	: CPropertyPage(CPPgIRC::IDD)
	, server(_T(""))
	, nick(_T(""))
	, name(_T(""))
	, minUser(_T(""))
	, useChannelFilter(FALSE)
	, perform(_T(""))
	, usePerform(FALSE)
	, timeStamp(FALSE)
	, listOnConnect(FALSE)
	, ignoreInfoMessages(FALSE)
	, ignoreEmuleMessages(FALSE)
	, serverDesc(_T(""))
	, nickDesc(_T(""))
	, filterDesc(_T(""))
	, performDesc(_T(""))
	, miscDesc(_T(""))
	, nameDesc(_T(""))
	, minUserDesc(_T(""))
{
}

CPPgIRC::~CPPgIRC()
{
}

void CPPgIRC::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_IRC_SERVER_BOX, server);
	DDX_Text(pDX, IDC_IRC_NICK_BOX, nick);
	DDX_Text(pDX, IDC_IRC_NAME_BOX, name);
	DDX_Text(pDX, IDC_IRC_MINUSER_BOX, minUser);
	DDX_Check(pDX, IDC_IRC_USECHANFILTER, useChannelFilter);
	DDX_Text(pDX, IDC_IRC_PERFORM_BOX, perform);
	DDX_Check(pDX, IDC_IRC_USEPERFORM, usePerform);
	DDX_Check(pDX, IDC_IRC_TIMESTAMP, timeStamp);
	DDX_Check(pDX, IDC_IRC_LISTONCONNECT, listOnConnect);
	DDX_Check(pDX, IDC_IRC_INFOMESSAGE, ignoreInfoMessages);
	DDX_Check(pDX, IDC_IRC_EMULEPROTO_INFOMESSAGE, ignoreEmuleMessages);
	DDX_Control(pDX, IDC_IRC_SERVER_BOX, serverEdit);
	DDX_Control(pDX, IDC_IRC_NICK_BOX, nickEdit);
	DDX_Control(pDX, IDC_IRC_NAME_BOX, nameEdit);
	DDX_Control(pDX, IDC_IRC_MINUSER_BOX, minUserEdit);
	DDX_Control(pDX, IDC_IRC_PERFORM_BOX, performEdit);
	DDX_Text(pDX, IDC_IRC_SERVER_FRM, serverDesc);
	DDX_Text(pDX, IDC_IRC_NICK_FRM, nickDesc);
	DDX_Text(pDX, IDC_IRC_FILTER_FRM, filterDesc);
	DDX_Text(pDX, IDC_IRC_PERFORM_FRM, performDesc);
	DDX_Text(pDX, IDC_IRC_MISC_FRM, miscDesc);
	DDX_Control(pDX, IDC_IRC_TIMESTAMP, timeStampCheck);
	DDX_Text(pDX, IDC_IRC_NAME_TEXT, nameDesc);
	DDX_Text(pDX, IDC_IRC_MINUSER_TEXT, minUserDesc);
	DDX_Control(pDX, IDC_IRC_USECHANFILTER, useChannelFilterCheck);
	DDX_Control(pDX, IDC_IRC_USEPERFORM, usePerformCheck);
	DDX_Control(pDX, IDC_IRC_LISTONCONNECT, listOnConnectCheck);
	DDX_Control(pDX, IDC_IRC_INFOMESSAGE, ignoreInfoMessageCheck);
	DDX_Control(pDX, IDC_IRC_EMULEPROTO_INFOMESSAGE, ignoreEmuleMessagesCheck);
}

BEGIN_MESSAGE_MAP(CPPgIRC, CPropertyPage)
	ON_BN_CLICKED(IDC_IRC_TIMESTAMP, OnBnClickedAddTimeStamp)
	ON_BN_CLICKED(IDC_IRC_USECHANFILTER, OnBnClickedUseFilter)
	ON_BN_CLICKED(IDC_IRC_USEPERFORM, OnBnClickedUsePerform)	
	ON_BN_CLICKED(IDC_IRC_INFOMESSAGE, OnBnClickedIgnoreInfoMessages)
	ON_BN_CLICKED(IDC_IRC_EMULEPROTO_INFOMESSAGE, OnBnClickedIgnoreEmuleProtoInfoMessages)
	ON_EN_CHANGE(IDC_IRC_NICK_BOX, OnEnChangeNick)
	ON_EN_CHANGE(IDC_IRC_PERFORM_BOX, OnEnChangePerformString)
	ON_EN_CHANGE(IDC_IRC_SERVER_BOX, OnEnChangeServer)
	ON_EN_CHANGE(IDC_IRC_NAME_BOX, OnEnChangeName)
	ON_EN_CHANGE(IDC_IRC_MINUSER_BOX, OnEnChangeUser)
	ON_BN_CLICKED(IDC_IRC_LISTONCONNECT, OnBnClickedListOnConnect)
END_MESSAGE_MAP()


BOOL CPPgIRC::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	nickEdit.SetLimitText(20);
	minUserEdit.SetLimitText(6);
	serverEdit.SetLimitText(40);
	nameEdit.SetLimitText(40);
	performEdit.SetLimitText(250);
	LoadSettings();
	Localize();
	m_bnickModified = false;

	return TRUE;
}

void CPPgIRC::LoadSettings(void)
{
	timeStamp = app_prefs->GetIRCAddTimestamp();		
	ignoreInfoMessages = app_prefs->GetIrcIgnoreInfoMessage();	
	ignoreEmuleMessages = app_prefs->GetIrcIgnoreEmuleProtoInfoMessage();	
	useChannelFilter = app_prefs->GetIRCUseChanFilter();
	usePerform = app_prefs->GetIrcUsePerform();		
	listOnConnect = app_prefs->GetIRCListOnConnect();
	server = app_prefs->GetIRCServer();
	nick = app_prefs->GetIRCNick();
	name = app_prefs->GetIRCChanNameFilter();
	perform = app_prefs->GetIrcPerformString();	
	minUser.Format(_T("%d"), app_prefs->GetIRCChannelUserFilter());	
	
	UpdateData(FALSE);	

	OnBnClickedUseFilter();
	OnBnClickedUsePerform();	

	SetModified(FALSE);	// FoRcHa
}


BOOL CPPgIRC::OnApply()
{   
	if(m_bModified)
	{
		UpdateData(TRUE);
		
		app_prefs->SetIRCAddTimestamp(timeStamp);		
		app_prefs->SetIrcIgnoreInfoMessage(ignoreInfoMessages);		
		app_prefs->SetIrcIgnoreEmuleProtoInfoMessage(ignoreEmuleMessages);		
		app_prefs->SetIRCListonConnect(listOnConnect);		
		app_prefs->SetIRCUseChanFilter(useChannelFilter);		
		app_prefs->SetIrcUsePerform(usePerform);
				
		if(!nick.IsEmpty())
		{			
			app_prefs->SetIRCNick(nick);
			if( theApp.emuledlg->ircwnd.GetLoggedIn() && m_bnickModified == true){
				m_bnickModified = false;
				theApp.emuledlg->ircwnd.SendString(CString(_T("NICK ")) + nick);
			}
		}
	
		if(!server.IsEmpty())		
			app_prefs->SetIRCServer(server);		
		
	
		if(!name.IsEmpty())					
			app_prefs->SetIRCChanNameFilter(name);
			
		if(!perform.IsEmpty())					
			app_prefs->SetIRCPerformString(perform);					
		else
			app_prefs->SetIRCPerformString(_T(" "));
	
		if(!minUser.IsEmpty())		
			app_prefs->SetIRCChanUserFilter( _tstoi(minUser));		
		else{
			app_prefs->SetIRCChanUserFilter(0);
		}
	
		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgIRC::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		serverDesc = GetResString(IDS_PW_SERVER);
		miscDesc = GetResString(IDS_PW_MISC);
		timeStampCheck.SetWindowText(GetResString(IDS_IRC_ADDTIMESTAMP));
		nickDesc = GetResString(IDS_PW_NICK);
		nameDesc = GetResString(IDS_IRC_NAME);
		minUserDesc = GetResString(IDS_UUSERS);
		filterDesc = GetResString(IDS_IRC_CHANNELLIST);
		useChannelFilterCheck.SetWindowText(GetResString(IDS_IRC_USEFILTER));
		performDesc = GetResString(IDS_IRC_PERFORM);
		usePerformCheck.SetWindowText(GetResString(IDS_IRC_USEPERFORM));
		listOnConnectCheck.SetWindowText(GetResString(IDS_IRC_LOADCHANNELLISTONCON));
		ignoreInfoMessageCheck.SetWindowText(GetResString(IDS_IRC_IGNOREINFOMESSAGE));
		ignoreEmuleMessagesCheck.SetWindowText(GetResString(IDS_IRC_EMULEPROTO_IGNOREINFOMESSAGE));
		UpdateData(FALSE);
	}
}

void CPPgIRC::OnBnClickedUsePerform()
{
	UpdateData(TRUE);
	performEdit.EnableWindow(usePerform);	

	SetModified();
}

void CPPgIRC::OnBnClickedUseFilter()
{
	UpdateData(TRUE);
	nameEdit.EnableWindow(useChannelFilter);	
	minUserEdit.EnableWindow(useChannelFilter);

	SetModified();
}