// EmEngine.h: interface for the CEmEngine class.
//
//////////////////////////////////////////////////////////////////////

#define WM_TASK_UI WM_USER + 1000

#ifdef NEW_SOCKETS
#if !defined(AFX_EMENGINE_H__F77B635A_251D_4554_9D96_DACFCA968759__INCLUDED_)
#define AFX_EMENGINE_H__F77B635A_251D_4554_9D96_DACFCA968759__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../Loggable.h"
#include "TaskProcessor_Main.h"
#include "TcpEngine.h"
#include "../EngineData.h"

class CServer;

class CEmEngine : public CLoggable
{
	HANDLE m_hStop; // termination event

	HWND m_hWndUI;

public:

	CTaskProcessor_Main	m_stMain;
	CTcpEngine			m_stTcp;
	CEngineData			m_stData;

	CEmEngine() :
		m_hStop(NULL),
		m_stMain(*this),
		m_stTcp(*this),
		m_hWndUI(NULL),
		m_stData(*this)
		{}
	~CEmEngine() { Uninit(); }

	bool Init(HWND hWndUI);
	void Uninit();

	void ConnectToServer(CServer* pServer = NULL);
	void ConnectToAnyServer();
	void DisconnectFromServer(SOCKET hPrevServer = NULL);

	inline bool IsShuttingDown() { return WAIT_TIMEOUT != WaitForSingleObject(m_hStop, 0); }

	inline void PushToUI(CTask* pTask)
	{
		if (pTask && !PostMessage(m_hWndUI, WM_TASK_UI, (WPARAM) pTask, 0))
		{
			// log
			delete pTask;
		}
	}
};

#endif // !defined(AFX_EMENGINE_H__F77B635A_251D_4554_9D96_DACFCA968759__INCLUDED_)
#endif