// Tasks.h
//
//////////////////////////////////////////////////////////////////////
#ifdef NEW_SOCKETS
#if !defined(AFX_TASKS_H__595D01B7_787E_4BAA_8F57_B70CFE759503__INCLUDED_)
#define AFX_TASKS_H__595D01B7_787E_4BAA_8F57_B70CFE759503__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../Loggable.h"

#include "TaskProcessor.h"

class CServer;
struct CEmClient;
struct CEmClient_Server;

struct CTask_Tcp : public CTask
{
	SOCKET m_hSocket;
	CTask_Tcp() : m_hSocket(INVALID_SOCKET) {}
};

struct CTask_Tcp_Accepted : public CTask_Tcp {
	virtual bool Process(CEmEngine&);
	in_addr m_nAddr;
	USHORT m_nPort;
	T_CLIENT_TYPE m_eType;
};

struct CTask_Tcp_Connected : public CTask_Tcp {
	virtual bool Process(CEmEngine&);
};

struct CTask_Tcp_Web : public CTask_Tcp {
	virtual bool Process(CEmEngine&);
	DWORD m_dwHeaderLen;
	DWORD m_dwContentLen;
	BYTE m_pBuf[0]; // variable size
	void* operator new (size_t nSize, DWORD dwDataSize) { return malloc(nSize + dwDataSize); }
	void operator delete (void* pPtr) { free(pPtr); }
	void operator delete (void* pPtr, DWORD) { free(pPtr); }
};

struct CTask_Tcp_Err : public CTask_Tcp {
	virtual bool Process(CEmEngine&);
	int m_nError;

	static bool Post(CEmEngine& stEngine, SOCKET hSocket, int nErrorCode);
};

struct CTask_Connect : public CTask {
	CTask_Connect(CServer* pServer = NULL);
	CTask_Connect(ULONG, USHORT, T_CLIENT_TYPE);
	CTask_Connect(LPCTSTR, USHORT, T_CLIENT_TYPE);
	virtual bool Process(CEmEngine&);

	ULONG	m_nAddr;
	USHORT	m_nPort;
	T_CLIENT_TYPE m_eType;
};

struct CTask_KillClient : public CTask {
	CTask_KillClient(CEmClient*);
	virtual bool Process(CEmEngine&);

	CEmClient* m_pClient;
};

struct CTask_ServerState : public CTask {
	CTask_ServerState(long, long, CServer*, CServer*);

	virtual bool Process(CEmEngine&);
	virtual void ProcessForUI(CEmEngine&);

	long		m_nConnectionState;
	long		m_nClientID;
	CServer*	m_pCurrentServer;
	CServer*	m_pNewServer;
};

#endif // !defined(AFX_TASKS_H__595D01B7_787E_4BAA_8F57_B70CFE759503__INCLUDED_)
#endif