// Tasks.cpp: implementation of the CTasks class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef NEW_SOCKETS
#include "OpCode.h"
#include "EmEngine.h"
#include "../emule.h"
#include "../EngineData.h"

// Client OpCodes

bool COpCode_HELLO::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	ASSERT(pClient); // this opcode is processed only in the main context

//	// here we can grab all user's info
//	COpCode_HELLOANSWER msg;
//	stEngine.m_stTcp.AllocSend(m_hSocket, msg);

	return true;
}

bool COpCode_HELLOANSWER::ProcessForClient(CEmEngine& stEngine, CEmClient*)
{
	return true;
}

// Server OpCodes

bool COpCode_SERVERMESSAGE::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	// Push itself to GUI processing thread
	stEngine.PushToUI(this);

	return false;
}

void COpCode_SERVERMESSAGE::ProcessForUI(CEmEngine&)
{
	theApp.emuledlg->AddServerMessageLine(_Msg);
}

bool COpCode_IDCHANGE::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	ASSERT(pClient); // this opcode is processed only in the main context

	// Disconnect from previous connected server, if any
	stEngine.DisconnectFromServer(stEngine.m_stData.GetConnectingServer());

	// Set info
	stEngine.m_stData.ConnectedTo(reinterpret_cast<CEmClient_Server*>(pClient));
	stEngine.m_stData.SetClientID(_ClientID);
	stEngine.m_stData.SetConnectionState(SERVER_CONNECTED);
/*
	if (theApp.glob_prefs->GetAddServersFromConn())
	{
		Packet* packet = new Packet(OP_GETSERVERLIST,0);
		theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
		SendPacket(packet,true);
	}
	if(theApp.glob_prefs->RestartWaiting())
		theApp.emuledlg->transferwnd.m_wndDownloadList.RestartWaitingDownloads();
 */

	return true;
}

bool COpCode_SEARCHRESULT::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	ASSERT(pClient); // this opcode is processed only in the main context

	return true;
}

bool COpCode_FOUNDSOURCES::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	ASSERT(pClient); // this opcode is processed only in the main context

	return true;
}

bool COpCode_SERVERSTATUS::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	ASSERT(pClient); // this opcode is processed only in the main context

	return true;
}

bool COpCode_SERVERIDENT::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	ASSERT(pClient); // this opcode is processed only in the main context

	return true;
}

bool COpCode_SERVERLIST::ProcessForClient(CEmEngine& stEngine, CEmClient* pClient)
{
	ASSERT(pClient); // this opcode is processed only in the main context

	return true;
}

bool COpCode_CALLBACKREQUESTED::ProcessForClient(CEmEngine& stEngine, CEmClient* )
{
	stEngine.m_stMain.AllocTcpConnect(_Client._Addr, _Client._Port, T_CLIENT_PEER);

	AddDebugLogLine(false, "Callback requested");

	return true;
}

bool COpCode_LOGINREQUEST::ProcessForClient(CEmEngine& stEngine, CEmClient* )
{
	return true;
}

#endif