//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// TransferWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "TransferWnd.h"
#include "otherfunctions.h"
#include "AddBuddy.h"
#include "CatDialog.h"
#include ".\transferwnd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define TRANS_ROLLUP		120
#define TRANS_DOWNLOADLIST	121
#define TRANS_UPLOADLIST	122
#define TRANS_QUEUELIST		123
#define TRANS_INFOLIST		124
#define TRANS_DOWNLOADTABS	125
#define TRANS_TABWINDOW		126
#define TRANS_DUMMY			130


class CDummyForTabs : public CWnd
{
public:
	CDummyForTabs(){ m_pChild = NULL; }

	void SetChild(CWnd* pChild){ m_pChild = pChild;	}

	CWnd* GetChild(){ return m_pChild; }

	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
	{
		EMULE_TRY
		NMHDR* pNMHDR = (NMHDR*)lParam;
		switch(pNMHDR->code)
		{
		case LVN_ITEMACTIVATE:
		case LVN_COLUMNCLICK:
		case NM_CLICK:
		case NM_DBLCLK:
			break;
		default:
			*pResult = GetParent()->GetParent()->SendMessage(WM_NOTIFY, wParam, lParam);
			return TRUE;
		}
		EMULE_CATCH2
		return CWnd::OnNotify(wParam, lParam, pResult);
	}


	afx_msg void OnSize(uInt nType, int cx, int cy)
	{
		EMULE_TRY
		if(m_pChild)
		{
			CRect r;
			GetClientRect(&r);
			r -= CSize(2,2);
			m_pChild->SetWindowPos(NULL, 0,0, r.Width(), r.Height(), SWP_NOMOVE|SWP_NOZORDER);
		}
		EMULE_CATCH2
	}

	DECLARE_DYNCREATE(CDummyForTabs)
	DECLARE_MESSAGE_MAP()

private:
	CWnd* m_pChild;
};

IMPLEMENT_DYNAMIC(CDummyForTabs, CWnd)

BEGIN_MESSAGE_MAP(CDummyForTabs, CWnd)
	ON_WM_SIZE()
END_MESSAGE_MAP()


// CTransferWnd dialog

IMPLEMENT_DYNAMIC(CTransferWnd, CDialog)
CTransferWnd::CTransferWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CTransferWnd::IDD, pParent)
{	
	m_bIsDragging = FALSE;
	m_pwndDummyForDownloadList = NULL;
}

CTransferWnd::~CTransferWnd()
{	
	m_pttDlTabToolTips->DestroyToolTipCtrl();
	SafeRollupItemHeights();
}

BEGIN_MESSAGE_MAP(CTransferWnd, CResizableDialog)
	//BEGIN Improved Tooltips
	//ON_NOTIFY_EX_RANGE(TTN_NEEDTEXT,0,0xFFFF,OnToolTipNotify)
	ON_NOTIFY_EX_RANGE(UDM_TOOLTIP_DISPLAY,0,0xFFFF,OnToolTipNotify)
	//END Improved Tooltips
	ON_WM_DESTROY()	// eklmn: bugfix(00): resource cleanup due to CResizableDialog
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	
//	ON_NOTIFY(TCN_SELCHANGE, TRANS_DOWNLOADTABS, OnTcnSelchangeDltab)
//	ON_NOTIFY(NM_RCLICK, TRANS_DOWNLOADTABS, OnNMRclickDltab)
//	ON_NOTIFY(NM_TABMOVED, TRANS_DOWNLOADTABS, OnTabMovement)
// ON_NOTIFY(LVN_BEGINDRAG, TRANS_DOWNLOADLIST, OnLvnBegindrag)

	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()


BOOL CTransferWnd::OnInitDialog()
{	
	EMULE_TRY

	CResizableDialog::OnInitDialog();
	m_bFirstShow=true;
	Localize();

	CRect rRollupArea;
	GetClientRect(&rRollupArea);
	rRollupArea.DeflateRect(11,11);
	
	m_wndRollup.Create(NULL, NULL, WS_CHILD|WS_VISIBLE/*|WS_CLIPCHILDREN*/, rRollupArea, this, TRANS_ROLLUP);

	CWnd *pParent = &m_wndRollup;
	CRect rItem = CRect(0,0,0,0);
	
	DWORD dwListStyle = WS_CHILD|WS_BORDER|WS_TABSTOP|LVS_REPORT|LVS_ALIGNLEFT|
						LVS_OWNERDRAWFIXED|LVS_SINGLESEL;
	DWORD dwTabStyle = WS_CHILD|WS_VISIBLE|TCS_HOTTRACK|TCS_SINGLELINE|TCS_TOOLTIPS;

	m_pwndDummyForDownloadList = new CDummyForTabs();
	m_pwndDummyForDownloadList->Create(AfxRegisterWndClass(0), "", WS_CHILD|WS_VISIBLE, rItem, pParent, TRANS_DUMMY);

	m_wndDownloadList.Create(WS_VISIBLE | dwListStyle, rItem, m_pwndDummyForDownloadList, TRANS_DOWNLOADLIST);
	m_wndUploadList.Create(WS_VISIBLE | dwListStyle, rItem, pParent, TRANS_UPLOADLIST);
	m_wndQueueList.Create(/*WS_VISIBLE |*/ dwListStyle, rItem, pParent, TRANS_QUEUELIST);
	m_wndInfoList.Create(WS_VISIBLE|WS_CHILD|WS_BORDER|WS_TABSTOP|LVS_REPORT|
							LVS_ALIGNLEFT|LVS_SINGLESEL, rItem, pParent, TRANS_INFOLIST);
	m_wndDlTabs.Create(dwTabStyle, CRect(0,0,0,20), pParent, TRANS_DOWNLOADTABS);	

	m_wndDlTabs.ModifyStyle(WS_CLIPSIBLINGS, 0);

	m_pwndDummyForDownloadList->SetChild(&m_wndDownloadList);

	AddBuddy(m_pwndDummyForDownloadList->m_hWnd, m_wndDlTabs.m_hWnd, BDS_TOP);

	CString strDownloads;
	strDownloads.Format(GetResString(IDS_RUP_DOWNINFO), theApp.downloadqueue->GetFileCount(),
						theApp.downloadqueue->GetTransferingFiles(),
						(float)theApp.downloadqueue->GetDatarate() / 1024);
	CString strUploads;	
	strUploads.Format(GetResString(IDS_RUP_UPINFO), theApp.uploadqueue->GetWaitingUserCount(),
					  theApp.uploadqueue->GetUploadQueueLength(), 
					  theApp.uploadqueue->GetBanCount(),
					  (float)theApp.uploadqueue->GetDatarate()/1024);
	
	m_wndRollup.InsertItem(GetResString(IDS_RUP_DOWNLOADS), strDownloads, m_pwndDummyForDownloadList, 0, TRUE);
	m_wndRollup.InsertItem(GetResString(IDS_RUP_UPLOADS), strUploads, &m_wndUploadList, 1, TRUE);
	m_wndRollup.InsertItem(GetResString(IDS_RUP_INFO), _T(""), &m_wndInfoList, 2, FALSE);

	AddAnchor(m_wndRollup.m_hWnd, TOP_LEFT, BOTTOM_RIGHT);
	
	InitRollupItemHeights();

	m_wndDownloadList.Init();
	m_wndUploadList.Init();
	m_wndQueueList.Init();

	m_wndDownloadList.SetOwner(this);
	m_wndUploadList.SetOwner(this);
	m_wndQueueList.SetOwner(this);
	m_wndDlTabs.SetOwner(this);
		
	m_nActiveWnd = 0;
	m_iRightClickIndex = -1;
	
	// create tooltip
	m_ttip.Create(this);
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 20000);
	m_ttip.SetDelayTime(TTDT_INITIAL, theApp.glob_prefs->GetToolTipDelay()*1000+25);	//netwolf: avoid jitter when delay is set to 0
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); // recognize \n chars!

	//BEGIN Improved Tooltips
	m_ttip.SetBehaviour(PPTOOLTIP_MULTIPLE_SHOW);
	m_ttip.SetNotify(m_hWnd);
	m_ttip.AddTool(&m_wndDownloadList, _T(""));	
	m_ttip.AddTool(&m_wndUploadList, _T(""));
//	m_ttip.SetFont(_T("Courier"), 9);
	//END Improved Tooltips

	// show & cat-tabs
  	sprintf(theApp.glob_prefs->GetCategory(0)->title, GetCatTitle(theApp.glob_prefs->GetAllcatType()) );

	sprintf(theApp.glob_prefs->GetCategory(0)->incomingpath,theApp.glob_prefs->GetIncomingDir());
	for (int ix=0;ix<theApp.glob_prefs->GetCatCount();ix++)
		m_wndDlTabs.InsertItem(ix,theApp.glob_prefs->GetCategory(ix)->title );
	m_pttDlTabToolTips= new CToolTipCtrl;
	m_pttDlTabToolTips->Create(this, TTS_NOPREFIX);
	m_wndDlTabs.SetToolTips(m_pttDlTabToolTips);
	UpdateTabToolTips();
	m_pttDlTabToolTips->SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); // recognize \n chars!
	m_pttDlTabToolTips->SetDelayTime(TTDT_AUTOPOP, 20000);
	m_pttDlTabToolTips->SetDelayTime(TTDT_INITIAL, 0);
	m_pttDlTabToolTips->Activate(TRUE);

	m_iOldToolTipItemDown = -1;
	m_iOldToolTipItemUp = -1;
	m_iOldToolTipItemQueue = -1;
		
	EMULE_CATCH

	return true;
}

// v- eklmn: bugfix(00): resource cleanup due to CResizableDialog
void CTransferWnd::OnDestroy()
{	
	if(m_pwndDummyForDownloadList)
	{
		m_pwndDummyForDownloadList->DestroyWindow();
		delete m_pwndDummyForDownloadList;
	}
	CResizableDialog::OnDestroy();
}

// ^- eklmn: bugfix(00): resource cleanup due to CResizableDialog

void CTransferWnd::DoDataExchange(CDataExchange* pDX)
{	
	CResizableDialog::DoDataExchange(pDX);
}

// CTransferWnd message handlers
BOOL CTransferWnd::PreTranslateMessage(MSG* pMsg)
{
	// eklmn: bugfix(07): Update tooltip only in case corresponding WM_MESSAGE
	if (pMsg->message == WM_LBUTTONDOWN || pMsg->message == WM_LBUTTONUP 
		|| pMsg->message == WM_RBUTTONDOWN || pMsg->message == WM_RBUTTONUP 
		|| pMsg->message == WM_MOUSEMOVE || pMsg->message == WM_MOUSEWHEEL
		|| pMsg->message == WM_KEYDOWN || pMsg->message == WM_SYSKEYDOWN )
	{
		m_ttip.RelayEvent(pMsg);
	}

	if (pMsg->message == WM_MOUSEMOVE || pMsg->message == WM_MOUSEWHEEL)
	{
		POINT point;
		::GetCursorPos(&point);
		if (point.x!=m_pLastMousePoint.x || point.y!=m_pLastMousePoint.y)
		{
			m_pLastMousePoint=point;

			// handle tooltip updating, when mouse is moved from one item to another
			UpdateToolTips();

			CPoint pt(point);
			m_nDropIndex=GetTabUnderMouse(&pt);

			if (m_nDropIndex!=m_nLastCatTT)
			{
				m_nLastCatTT=m_nDropIndex;
				if (m_nDropIndex!=-1)
					UpdateTabToolTips(m_nDropIndex);
			}
		}
	}

	if(pMsg->message == USRMSG_SWITCHUPLOADLIST)
		SwitchUploadList();

	return CResizableDialog::PreTranslateMessage(pMsg);
}

void CTransferWnd::UpdateToolTips(void)
{	
	EMULE_TRY

	CListCtrl *pListCtrl = &m_wndDownloadList;//(CListCtrl*)m_wndRollup.GetItemClient(0);
	int sel = GetItemUnderMouse(pListCtrl);	// this is a quick fix,
	if (sel != -1)							// we should find a better solution
	{
		if (sel != m_iOldToolTipItemDown)
		{
			if(m_ttip.IsWindowVisible())
			{	
				//BEGIN Improved Tooltips
				//m_ttip.Update();
				m_ttip.UpdateData();
				//END Improved Tooltips
			}
			m_iOldToolTipItemDown = sel;
			return;
		}
	}

	int sel2 = GetItemUnderMouse((CListCtrl*)m_wndRollup.GetItemClient(1));	// see above
	if (sel2 != -1)
	{
		if (sel2 != m_iOldToolTipItemUp)
		{
			if(m_ttip.IsWindowVisible())
			{	
				// Improved Tooltips
				m_ttip.UpdateData();
			}
			m_iOldToolTipItemUp = sel2;
			return;
		}
	}
	if (sel == -1 && sel2 == -1)
		m_ttip.Pop();

	EMULE_CATCH
}

int CTransferWnd::GetItemUnderMouse(CListCtrl* ctrl)
{	
	EMULE_TRY

	CPoint pt;
	::GetCursorPos(&pt);
	ctrl->ScreenToClient(&pt);
	LVHITTESTINFO hit, subhit;
	hit.pt = pt;
	subhit.pt = pt;
	ctrl->SubItemHitTest(&subhit);
	int sel = ctrl->HitTest(&hit);
	if (sel != LB_ERR && (hit.flags & LVHT_ONITEM))
		if (subhit.iSubItem == 0)
			return sel;

	EMULE_CATCH

	return LB_ERR;
}

BOOL CTransferWnd::OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult)
{	
	EMULE_TRY

	//BEGIN Improved Tooltips
	//TOOLTIPTEXT *pText = (TOOLTIPTEXT *)pNMH;
	//int control_id = ::GetDlgCtrlID((HWND)pNMH->idFrom);
	NM_PPTOOLTIP_DISPLAY * pNotify = (NM_PPTOOLTIP_DISPLAY*)pNMH;
	int control_id = CWnd::FromHandle(pNotify->ti->hWnd)->GetDlgCtrlID();
	//END Improved Tooltips

	if (!control_id)
		return FALSE;

	CString info;
	if (control_id == TRANS_DOWNLOADLIST)
	{
		if (m_wndDownloadList.GetItemCount() < 1)
			return FALSE;

		int sel = GetItemUnderMouse(&m_wndDownloadList);
		if (sel < 0 || sel == 65535)
			return FALSE;

		// build info text and display it
		ST_CTRLITEM* pContent = (ST_CTRLITEM*)m_wndDownloadList.GetItemData(sel);
		if(pContent->eType == FILE_TYPE)	// for downloading files
		{
			CPartFile* partfile = (CPartFile*)pContent->pValue;

			//BEGIN Improved Tooltips
			info = partfile->GetDownloadFileInfo4Tooltips();

			SHFILEINFO shfi;
			memset(&shfi,0,sizeof(shfi));
			SHGetFileInfo(partfile->GetFileName(), FILE_ATTRIBUTE_NORMAL, &shfi, sizeof(shfi), SHGFI_ICON|SHGFI_USEFILEATTRIBUTES);
			pNotify->ti->hIcon = shfi.hIcon;

			m_wndDownloadList.SetFocus();
			//END Improved Tooltips
		}
		else if (pContent->eType == AVAILABLE_SOURCE || pContent->eType == UNAVAILABLE_SOURCE) // for sources
		{
			bool bA4AF = IsAskedForAnotherFile(pContent);
			CUpDownClient* client = (CUpDownClient*)pContent->pValue;
			in_addr server;
			server.S_un.S_addr = client->GetServerIP();

			//BEGIN Improved Tooltips
			info.Format(GetResString(IDS_TT_USERINFO)
				+GetResString(IDS_TT_CLIENT)
				+GetResString(IDS_TT_SERVER)
				+GetResString(IDS_TT_SOURCEINFO)
				+GetResString(IDS_TT_SOURCEINFO2),
						client->GetUserName(), client->GetUserID(),
						client->GetFullIP(), client->GetUserPort(), 
						inet_ntoa(server), client->GetServerPort(),
						client->GetAskedCountDown(), client->GetAvailablePartCount());	//eklmn: bugfix(15): show values for download asked
			if (!bA4AF)
			{	// normal client
				CString sClientSrcName;
				sClientSrcName.Format(GetResString(IDS_TT_CLIENTSOURCENAME),
					CString(client->GetClientFilename()));
				info += sClientSrcName;
			}
			else
			{
				//Cax2- get local file name
				try
				{
					CString sA4AFFileName;
					sA4AFFileName.Format(GetResString(IDS_TT_ASKEDFAF),
						client->reqfile->GetFileName());
					info += sA4AFFileName;
				}
				catch(...){}
            }
         //-For File Comment-// 
		     try 
			 { 
				if (!bA4AF)
				{
					if (client->GetFileComment() != "")
					{ 
						CString sFileComment;
						sFileComment.Format(GetResString(IDS_TT_CMT_READ), CString(client->GetFileComment()));
						info += sFileComment; 
					} 
					else 
						info += GetResString(IDS_TT_CMT_NONE); // No comment entered

					if (GetRateString(client->GetFileRate())==GetResString(IDS_CMT_NOTRATED))
						info += GetResString(IDS_TT_CMT_NOTRATED);
					else
					{
						CString sRate;
						sRate.Format(GetResString(IDS_TT_CMT_RATING),
								GetRateString(client->GetFileRate()));
						info += sRate;
					} 
				}
			} 
			catch(...) 
			{ 
				//Information not received = not connected or connecting 
				info += GetResString(IDS_TT_CMT_NOTCONNECTED); 
			} 
	         //-End file comment-//

			//Set the tooltip icon - Hehe with new icons this time :P
			switch(client->GetClientSoft()) 
			{
				case SO_CDONKEY:
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(8);
					break;
				case SO_LMULE:
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(9);
					break;
				case SO_SHAREAZA:
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(10);
					break;
				case SO_EDONKEYHYBRID:
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(3);
					break;
				case SO_MLDONKEY:
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(2);
					break;
				case SO_EMULE:
				case SO_OLDEMULE:
					if(client->credits->GetCurrentIdentState(client->GetIP()) != IS_IDENTIFIED)
						pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(11);
					else
						pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(1);
					break;
				case SO_EDONKEY:
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(0);
					break;
				default:
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(7);
					break;
			}
			//END Improved Tooltips
		}
	}
	else if (control_id == TRANS_UPLOADLIST)
	{
		if (m_wndUploadList.GetItemCount() < 1)
			return FALSE;

		int sel = GetItemUnderMouse(&m_wndUploadList);
		if (sel < 0 || sel == 65535)
			return FALSE;

		CUpDownClient* client = (CUpDownClient*)m_wndUploadList.GetItemData(sel);

		info = client->GetUploadFileInfo4Tooltips();

		//Set the tooltip icon - Hehe with new icons this time :P
		switch(client->GetClientSoft())
		{
			case SO_CDONKEY:
				pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(8);
				break;
			case SO_LMULE:
				pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(9);
				break;
			case SO_SHAREAZA:
				pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(10);
				break;
			case SO_EDONKEYHYBRID:
				pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(3);
				break;
			case SO_MLDONKEY:
				pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(2);
				break;
			case SO_EMULE:
			case SO_OLDEMULE:
				if(client->credits->GetCurrentIdentState(client->GetIP()) != IS_IDENTIFIED)
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(11);
				else
					pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(1);
				break;
			case SO_EDONKEY:
				pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(0);
				break;
			default:
				pNotify->ti->hIcon = m_wndUploadList.imagelist.ExtractIcon(7);
				break;
		}

		m_wndUploadList.SetFocus();
		//END Improved Tooltips
	}
	else if (control_id == TRANS_QUEUELIST)
	{
		if (m_wndQueueList.GetItemCount() < 1)
			return FALSE;

		int sel = GetItemUnderMouse(&m_wndQueueList);
		if (sel < 0 || sel == 65535)
			return FALSE;

		// build info text and display it
		CUpDownClient* client = (CUpDownClient*)m_wndUploadList.GetItemData(sel);
		in_addr server;
		server.S_un.S_addr = client->GetServerIP();

		info.Format(_T("Nickname: %s (UserID: %u)\n")
					_T("Client %s:%d\n")
					_T("Server %s:%d\n")
					_T("AskedCount: %d - AvailablePartCount: %d"),
					client->GetUserName(), client->GetUserID(),
					client->GetFullIP(), client->GetUserPort(), 
					inet_ntoa(server), client->GetServerPort(),
					client->GetAskedCount(), client->GetAvailablePartCount());

	}
	pNotify->ti->sTooltip = info;

	EMULE_CATCH

	return TRUE;
}

void CTransferWnd::SwitchUploadList()
{	
	EMULE_TRY

	switch(m_nActiveWnd)
	{
		case 0:
		{	
			m_nActiveWnd = 1;
			m_wndRollup.SetText(1, GetResString(IDS_ONQUEUE), true);
			m_wndUploadList.ShowWindow(SW_HIDE);
			m_wndRollup.SetItemClient(1, &m_wndQueueList);
			m_wndRollup.Invalidate();
			break;
		}
		case 1:
		{	
			m_nActiveWnd = 0;
			m_wndRollup.SetText(1, GetResString(IDS_RUP_UPLOADS), true);
			m_wndQueueList.ShowWindow(SW_HIDE);
			m_wndRollup.SetItemClient(1, &m_wndUploadList);
			m_wndRollup.Invalidate();
			break;
		}
		default: break;
	}

	EMULE_CATCH
}

void CTransferWnd::Localize()
{	
	EMULE_TRY

	m_wndDownloadList.Localize();
	m_wndUploadList.Localize();
	m_wndQueueList.Localize();
	m_wndInfoList.Localize();

	//Cax2 - localize the rollup control
	m_wndRollup.SetText(0,GetResString(IDS_RUP_DOWNLOADS), true);
	m_wndRollup.SetText(1,GetResString((m_nActiveWnd==0)?IDS_RUP_UPLOADS:IDS_ONQUEUE), true);
	m_wndRollup.SetText(2,GetResString(IDS_RUP_INFO), true);
	if(m_bFirstShow)
	{
		m_bFirstShow = false;
		m_wndInfoList.SetColumn(theApp.glob_prefs->GetDetailColumnWidth());
	}

	EMULE_CATCH
}

void CTransferWnd::UpdateDownloadHeader()
{	
	EMULE_TRY

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_DOWNINFO), theApp.downloadqueue->GetFileCount(),
						theApp.downloadqueue->GetTransferingFiles(),
							(float)theApp.downloadqueue->GetDatarate()/1024);
	m_wndRollup.SetText(0, strBuffer);

	EMULE_CATCH
}

void CTransferWnd::UpdateUploadHeader()
{	
	EMULE_TRY

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_UPINFO), theApp.uploadqueue->GetWaitingUserCount(),
						theApp.uploadqueue->GetUploadQueueLength(), 
							theApp.uploadqueue->GetBanCount(),
								(float)theApp.uploadqueue->GetDatarate()/1024);
	m_wndRollup.SetText(1, strBuffer);

	EMULE_CATCH
}

void CTransferWnd::UpdateInfoHeader()
{		
	EMULE_TRY

	CString strInfoHeader = _T("");

	switch(m_wndInfoList.GetType())
	{	
		case 1: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOUSER), m_wndInfoList.GetName()); 
			break;
		case 2: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOFILE), m_wndInfoList.GetName()); 
			break;
		default : 
			strInfoHeader = "";
			break;
	}
	
	m_wndRollup.SetText(2, strInfoHeader);

	EMULE_CATCH
}

void CTransferWnd::InitRollupItemHeights()
{	
	EMULE_TRY

	float fItemHeights[3][8];
		
	FILE *f;
	CString fullpath;
	fullpath.Format(_T("%sgui.dat"), theApp.glob_prefs->GetConfigDir());
	f = _tfopen(fullpath, _T("rb"));	
	
	bool bUseDefault = false;

	if(f)
	{
		TCHAR cTemp[512];
		TCHAR *pToken;
        TCHAR seps[] = _T("|\n");

		for(int exp = 0; exp < 8; exp++)
		{
			if(!_fgetts(cTemp, 512, f))
			{
				bUseDefault = true;
				break;
			}

			float fTotalHeight = 0;
			pToken = _tcstok(cTemp, seps);
			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					exp = 8;
					break;
				}

				fItemHeights[i][exp] = _tstof(pToken);
//				TRACE("fItemHeights[%d][%d] = %f\r\n", i, exp, _tstof(pToken));
				pToken = _tcstok(NULL, seps);

				if(fItemHeights[i][exp] < 0)	// this should never happen
				{
					bUseDefault = true;
					exp = 8;
					i = 3;
				}
				fTotalHeight += fItemHeights[i][exp];
			}
			
			// this should also never happen
			if(fTotalHeight >= 101 || fTotalHeight <= 99 && fTotalHeight != 0) // i'm very tolerant ;)
			{
				bUseDefault = true;
				exp = 8;
			}
		}	

		if(!_fgetts(cTemp, 512, f))
			bUseDefault = true;

		if(!bUseDefault)
		{
			pToken = _tcstok(cTemp, seps);
			
			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					i = 3;
				}

				m_wndRollup.ExpandItem(i, _tstoi(pToken));
				pToken = _tcstok(NULL, seps);
			}
		}
		
		fclose(f);
	}
	else
		bUseDefault = true;
	
	if(bUseDefault)
	{
		BYTE bExpandedItems; 

		bExpandedItems = 0x00;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x01;
		fItemHeights[0][bExpandedItems] = 100;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x02;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 100;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x03;
		fItemHeights[0][bExpandedItems] = 70;
		fItemHeights[1][bExpandedItems] = 30;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x04;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 100;

		bExpandedItems = 0x05;
		fItemHeights[0][bExpandedItems] = 70;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 30;

		bExpandedItems = 0x06;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 70;
		fItemHeights[2][bExpandedItems] = 30;

		bExpandedItems = 0x07;
		fItemHeights[0][bExpandedItems] = 50;
		fItemHeights[1][bExpandedItems] = 25;
		fItemHeights[2][bExpandedItems] = 25;
	}

	m_wndRollup.SetItemHeights(0, fItemHeights[0], 8);
	m_wndRollup.SetItemHeights(1, fItemHeights[1], 8);
	m_wndRollup.SetItemHeights(2, fItemHeights[2], 8);

	EMULE_CATCH
}

void CTransferWnd::SafeRollupItemHeights()
{	
	EMULE_TRY

	FILE *f;
	CString fullpath; // i_a
	fullpath.Format(_T("%sgui.dat"), theApp.glob_prefs->GetConfigDir());
	f = _tfopen(fullpath, _T("wb"));	

	if(f)
	{
		for(int exp = 0; exp < 8; exp++)
		{	
			float f1,f2,f3;
			f1 = m_wndRollup.GetItem(0)->pSizes[exp];
			f2 = m_wndRollup.GetItem(1)->pSizes[exp];
			f3 = m_wndRollup.GetItem(2)->pSizes[exp];
	
			// get rid off some rounding errors: ///
			if(f3)
				f3 = f1 ? (f2 ? (100 - f1 - f2) : (100 - f1)) : (100 - f2);
			else if(f2)
				f2 = 100 - f1;				
			////////////////////////////////////////

			fprintf(f, "%f|%f|%f\n", f1, f2, f3);
		}
		fprintf(f, "%d|%d|%d\n", m_wndRollup.GetItem(0)->pHeader->IsExpanded(),
					m_wndRollup.GetItem(1)->pHeader->IsExpanded(), m_wndRollup.GetItem(2)->pHeader->IsExpanded());
		fclose(f);
	}

	EMULE_CATCH
}

BOOL CTransferWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{	
	if (wParam >= MP_CAT_SET0 && wParam<=MP_CAT_SET0+20) 
	{
		theApp.glob_prefs->SetAllcatType(wParam-MP_CAT_SET0);
		m_nLastCatTT=-1;
		m_wndDlTabs.SetCurSel(0);
		m_wndDownloadList.ChangeCategory(0);
		EditCatTabLabel(0, GetCatTitle(theApp.glob_prefs->GetAllcatType()));
	}

	switch (wParam)
	{
		case USRMSG_SWITCHUPLOADLIST:
			SwitchUploadList();
			break;

		case USRMSG_CLEARCOMPLETED:
			m_wndDownloadList.ClearCompleted();
			break;

		case MP_CAT_ADD:
		{
			m_nLastCatTT = -1;
			int newindex = AddCategory("?", theApp.glob_prefs->GetIncomingDir(), "", "", true);
			CCatDialog dialog(newindex);
			if(dialog.DoModal() == IDCANCEL)
			{
				theApp.glob_prefs->RemoveCat(newindex);
				m_wndDlTabs.DeleteItem(newindex);
				m_wndDlTabs.SetCurSel(0);
				m_wndDownloadList.ChangeCategory(0);
				theApp.glob_prefs->SaveCats();
				if(theApp.glob_prefs->GetCatCount() == 1) 
				{
					theApp.glob_prefs->SetAllcatType(0);
				}
				theApp.emuledlg->searchwnd.UpdateCatTabs();
			}
			theApp.emuledlg->searchwnd.UpdateCatTabs();
			EditCatTabLabel(newindex, theApp.glob_prefs->GetCategory(newindex)->title);
			theApp.glob_prefs->SaveCats();
			break;
		}

		case MP_CAT_EDIT:
		{
			m_nLastCatTT = -1;
			CCatDialog dialog(m_iRightClickIndex);
			dialog.DoModal();

			CString csName;
			csName.Format("%s", theApp.glob_prefs->GetCategory(m_iRightClickIndex)->title );
			EditCatTabLabel(m_iRightClickIndex,csName);
			theApp.emuledlg->searchwnd.UpdateCatTabs();
			theApp.glob_prefs->SaveCats();
			break;
		}
		case MP_CAT_REMOVE:
		{
			m_nLastCatTT = -1;
			theApp.downloadqueue->ResetCatParts(m_iRightClickIndex);
			theApp.glob_prefs->RemoveCat(m_iRightClickIndex);
			m_wndDlTabs.DeleteItem(m_iRightClickIndex);
			m_wndDlTabs.SetCurSel(0);
			m_wndDownloadList.ChangeCategory(0);
			theApp.glob_prefs->SaveCats();
			if(theApp.glob_prefs->GetCatCount() == 1) 
			{
				theApp.glob_prefs->SetAllcatType(0);
			}
			theApp.emuledlg->searchwnd.UpdateCatTabs();
			break;
		}
		case MP_PRIOLOW:
		{
			theApp.downloadqueue->SetCatPrio(m_iRightClickIndex,PR_LOW);
			break;
		}
		case MP_PRIONORMAL:
		{
			theApp.downloadqueue->SetCatPrio(m_iRightClickIndex,PR_NORMAL);
			break;
		}
		case MP_PRIOHIGH:
		{
			theApp.downloadqueue->SetCatPrio(m_iRightClickIndex,PR_HIGH);
			break;
		}
		case MP_PRIOAUTO:
		{
			theApp.downloadqueue->SetCatPrio(m_iRightClickIndex,PR_AUTO);
			break;
		}
		case MP_PAUSE:
		{
			theApp.downloadqueue->SetCatStatus(m_iRightClickIndex,MP_PAUSE);
			break;
		}
		case MP_STOP:
		{
			theApp.downloadqueue->SetCatStatus(m_iRightClickIndex,MP_STOP);
			break;
		}
		case MP_CANCEL:
		{
			if (AfxMessageBox(GetResString(IDS_Q_CANCELDL),MB_ICONQUESTION|MB_YESNO) == IDYES)
			{	
				theApp.downloadqueue->SetCatStatus(m_iRightClickIndex,MP_CANCEL);
			}
			break;
		}
		case MP_RESUME:
		{
			theApp.downloadqueue->SetCatStatus(m_iRightClickIndex,MP_RESUME);
			break;
		}
		case MP_RESUMENEXT:
		{
			theApp.downloadqueue->StartPausedDownload(m_iRightClickIndex);
			break;
		}
	}
	
	return CResizableDialog::OnCommand(wParam, lParam);
}

int CTransferWnd::GetTabUnderMouse(CPoint* point) 
{	
	TCHITTESTINFO hitinfo;
	CRect rect;
	m_wndDlTabs.GetWindowRect(&rect);
	point->Offset(0-rect.left,0-rect.top);
	hitinfo.pt = *point;

	if(m_wndDlTabs.GetItemRect(0, &rect))
	{
		if(hitinfo.pt.y< rect.top+30 && hitinfo.pt.y >rect.top-30)
		{	
			hitinfo.pt.y = rect.top;
		}
	}

	// Find the destination tab...
	unsigned int nTab = m_wndDlTabs.HitTest(&hitinfo);
	if(hitinfo.flags != TCHT_NOWHERE)
		return nTab;
	else 
		return -1;
}

void CTransferWnd::UpdateTabToolTips(int tab) 
{	
	uint8 i;

	if(tab==-1) 
	{
		for (i=0;i<m_pttDlTabToolTips->GetToolCount();i++)
			m_pttDlTabToolTips->DelTool(&m_wndDlTabs,i+1);

		for (i = 0; i < m_wndDlTabs.GetItemCount(); i++)
		{
			CRect r;
			m_wndDlTabs.GetItemRect(i, &r);
			VERIFY(m_pttDlTabToolTips->AddTool(&m_wndDlTabs, GetTabStatistic(i), &r, i+1));
		}
	} 
	else 
	{
		CRect r;
		m_wndDlTabs.GetItemRect(tab, &r);

		m_pttDlTabToolTips->DelTool(&m_wndDlTabs,tab+1);
		VERIFY(m_pttDlTabToolTips->AddTool(&m_wndDlTabs, GetTabStatistic(tab), &r, tab+1));
	}
}

CString CTransferWnd::GetTabStatistic(uint8 tab) 
{	
	uint16 count,dwl;
	count= dwl = 0;
	float speed = 0;
	uint64 size = 0;
	uint64 trsize = 0;
	CPartFile* cur_file;

	for(int i=0;i<theApp.downloadqueue->GetFileCount();i++) 
	{
		cur_file=theApp.downloadqueue->GetFileByIndex(i);
		
		if(cur_file != 0) 
		{
			if(CheckShowItemInGivenCat(cur_file, tab)) 
			{
				count++;
				if(cur_file->GetTransferingSrcCount() > 0) 
					dwl++;
				speed += cur_file->GetDatarate() / 1024.0f;
				size += cur_file->GetFileSize();
				trsize += cur_file->GetCompletedSize();
			}
		}
	}

	CString strTitle;
	strTitle.Format("%s: %i/%i\n%s: %.1f %s\n%s: %s/%s",
		GetResString(IDS_DOWNLOADING), dwl, count,GetResString(IDS_DL_SPEED) ,speed,GetResString(IDS_KBYTESEC),
		GetResString(IDS_DL_SIZE),CastItoXBytes(trsize),CastItoXBytes(size) );
	return strTitle;
}

void CTransferWnd::OnTcnSelchangeDltab(NMHDR *pNMHDR, LRESULT *pResult)
{	
	m_wndDownloadList.ChangeCategory(m_wndDlTabs.GetCurSel());
	*pResult = 0;
}

void CTransferWnd::OnNMRclickDltab(NMHDR *pNMHDR, LRESULT *pResult)
{
	// Menu for category
	CTitleMenu menu;
	POINT point;
	::GetCursorPos(&point);

	CPoint pt(point);
	m_iRightClickIndex = GetTabUnderMouse(&pt);

	UINT flag;
	flag = (m_iRightClickIndex == 0) ? MF_GRAYED : MF_STRING;

	CMenu m_CatMenu;
	m_CatMenu.CreateMenu();

	CMenu m_PrioMenu;
	m_PrioMenu.CreateMenu();
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOAUTO, GetResString(IDS_PRIOAUTO));

	menu.CreatePopupMenu();
	menu.AddMenuTitle(GetResString(IDS_CAT));

	if(m_iRightClickIndex == 0)
	{
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0,GetResString(IDS_ALL));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+1,GetResString(IDS_ALLOTHERS));
		m_CatMenu.AppendMenu(MF_SEPARATOR);
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+2,GetResString(IDS_STATUS_NOTCOMPLETED));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+3,GetResString(IDS_DL_TRANSFCOMPL));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+4,GetResString(IDS_WAITING));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+5,GetResString(IDS_DOWNLOADING));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+6,GetResString(IDS_ERRORLIKE));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+7,GetResString(IDS_PAUSED));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+8,GetResString(IDS_STOPPED));
		m_CatMenu.AppendMenu(MF_SEPARATOR);
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+10,GetResString(IDS_VIDEO));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+11,GetResString(IDS_AUDIO));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+12,GetResString(IDS_SEARCH_ARC));
		m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+13,GetResString(IDS_SEARCH_CDIMG));
		
		m_CatMenu.CheckMenuItem( MP_CAT_SET0+theApp.glob_prefs->GetAllcatType() ,MF_CHECKED | MF_BYCOMMAND);

		menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_CatMenu.m_hMenu, GetResString(IDS_CHANGECATVIEW));
		menu.AppendMenu(MF_SEPARATOR);
	}

	menu.AppendMenu(MF_STRING,MP_CAT_ADD,GetResString(IDS_CAT_ADD));
	menu.AppendMenu(flag,MP_CAT_EDIT,GetResString(IDS_CAT_EDIT));
	menu.AppendMenu(flag,MP_CAT_REMOVE, GetResString(IDS_CAT_REMOVE));
	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PrioMenu.m_hMenu, GetResString(IDS_PRIORITY));

	menu.AppendMenu(MF_STRING,MP_CANCEL,GetResString(IDS_MAIN_BTN_CANCEL));
	menu.AppendMenu(MF_STRING,MP_STOP, GetResString(IDS_DL_STOP));
	menu.AppendMenu(MF_STRING,MP_PAUSE, GetResString(IDS_DL_PAUSE));
	menu.AppendMenu(MF_STRING,MP_RESUME, GetResString(IDS_DL_RESUME));
	menu.AppendMenu(MF_STRING,MP_RESUMENEXT, GetResString(IDS_DL_RESUMENEXT));
	

	menu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	VERIFY(m_PrioMenu.DestroyMenu());
	VERIFY(m_CatMenu.DestroyMenu());
	VERIFY(menu.DestroyMenu());

	*pResult = 0;
}

void CTransferWnd::OnLvnBegindrag(NMHDR *pNMHDR, LRESULT *pResult)
{	
	int iSel = m_wndDownloadList.GetSelectionMark();
	if(iSel==-1) 
		return;
	
	ST_CTRLITEM *pListItem = (ST_CTRLITEM*)m_wndDownloadList.GetItemData(iSel);
	if(pListItem == NULL)
		return;

	if(pListItem->eType != FILE_TYPE)
		return;
	
	m_bIsDragging = true;

	POINT pt;
	::GetCursorPos(&pt);
	
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	m_nDragIndex = pNMLV->iItem;
	m_pDragImage = m_wndDownloadList.CreateDragImage(m_wndDownloadList.GetSelectionMark(),&pt);
    m_pDragImage->BeginDrag(0, CPoint(0,0));
    m_pDragImage->DragEnter(GetDesktopWindow(), pNMLV->ptAction);
    SetCapture();
	m_nDropIndex = -1;

	*pResult = 0;
}

void CTransferWnd::OnMouseMove(UINT nFlags, CPoint point)
{	
	if(!(nFlags & MK_LBUTTON)) 
		m_bIsDragging = false;

	if(m_bIsDragging)
	{
		CPoint pt(point);           //get our current mouse coordinates
		ClientToScreen(&pt);        //convert to screen coordinates
		
		m_nDropIndex=GetTabUnderMouse(&pt);
		m_wndDlTabs.SetCurSel(m_nDropIndex);
		m_wndDlTabs.Invalidate();
	
		::GetCursorPos(&pt);
		pt.y -= 10;

		m_pDragImage->DragMove(pt); //move the drag image to those coordinates
	}
}

void CTransferWnd::OnLButtonUp(UINT nFlags, CPoint point)
{	
	if(m_bIsDragging)
	{
		ReleaseCapture();
		m_bIsDragging = false;
		m_pDragImage->DragLeave(GetDesktopWindow());
		m_pDragImage->EndDrag();
		delete m_pDragImage;
		
		if(m_nDropIndex>-1 && (m_wndDownloadList.m_nCurTab == 0 ||
			(m_wndDownloadList.m_nCurTab > 0 && 
				m_nDropIndex != m_wndDownloadList.m_nCurTab))) 
		{
			CPartFile* file;
			int index = -1; 
			POSITION pos = m_wndDownloadList.GetFirstSelectedItemPosition(); 
			while(pos != NULL) 
			{ 
				index = m_wndDownloadList.GetNextSelectedItem(pos); 
				if(index > -1) 
				{
					ST_CTRLITEM *pListItem = (ST_CTRLITEM*)m_wndDownloadList.GetItemData(index);
					if(pListItem != NULL)
					{
						if(pListItem->eType == FILE_TYPE)
						{
							file = (CPartFile*)pListItem->pValue;
							file->SetCategory(m_nDropIndex);
						}
					}
				} 
			}
			m_wndDlTabs.SetCurSel(m_wndDownloadList.m_nCurTab);
			if(m_wndDlTabs.GetCurSel() > 0 || 
				(theApp.glob_prefs->GetAllcatType() == 1 && 
					m_wndDlTabs.GetCurSel()==0))
			{
				m_wndDownloadList.ChangeCategory(m_wndDlTabs.GetCurSel());
			}
			UpdateCatTabTitles();
		} 
		else 
			m_wndDlTabs.SetCurSel(m_wndDownloadList.m_nCurTab);

		m_wndDownloadList.Invalidate();
	}
}

void CTransferWnd::OnDblclickDltab()
{	
	POINT point;
	::GetCursorPos(&point);
	CPoint pt(point);
	int tab = GetTabUnderMouse(&pt);
	if(tab < 1) 
		return;

	m_iRightClickIndex = tab;
	OnCommand(MP_CAT_EDIT,0);
}

void CTransferWnd::UpdateCatTabTitles() 
{	
	for(uint8 i=0; i<m_wndDlTabs.GetItemCount(); i++)
	{	
		EditCatTabLabel(i, (i == 0) ? GetCatTitle(theApp.glob_prefs->GetAllcatType()) : 
						theApp.glob_prefs->GetCategory(i)->title);
	}
	UpdateTabToolTips();
}

void CTransferWnd::EditCatTabLabel(int index,CString newlabel) 
{	
	TCITEM tabitem;
	tabitem.mask = TCIF_PARAM;
	m_wndDlTabs.GetItem(index,&tabitem);
	tabitem.mask = TCIF_TEXT;

	if(theApp.glob_prefs->ShowCatTabInfos()) 
	{
		CPartFile* cur_file;
		uint16 count,dwl;
		count = dwl = 0;
		for(int i = 0; i < theApp.downloadqueue->GetFileCount(); i++) 
		{
			cur_file=theApp.downloadqueue->GetFileByIndex(i);
			if(cur_file == 0) 

				continue;

			if(CheckShowItemInGivenCat(cur_file,index)) 
			{
				count++;
				if(cur_file->GetTransferingSrcCount() > 0) 
					dwl++;

//				speed+=cur_file->GetDatarate()/1024.0f;
//				size+=cur_file->GetFileSize();
//				trsize+=cur_file->GetCompletedSize();
			}
		}
		CString title=newlabel;
		newlabel.Format("%s (%i/%i)",title,dwl,count);
	}

	tabitem.pszText = newlabel.LockBuffer();
	m_wndDlTabs.SetItem(index,&tabitem);
	newlabel.UnlockBuffer();
	m_wndDlTabs.Invalidate();
}

int CTransferWnd::AddCategory(CString newtitle,CString newincoming,CString newcomment, 
								CString newautocat, bool addTab)
{
	Category_Struct* newcat = new Category_Struct;

	sprintf(newcat->title, newtitle);
	newcat->prio = 0;
	sprintf(newcat->incomingpath, newincoming);
	sprintf(newcat->comment, newcomment);
	sprintf(newcat->autocat, newautocat);

	int index = theApp.glob_prefs->AddCat(newcat);
	if(addTab) 
		m_wndDlTabs.InsertItem(index,newtitle);

	m_wndDlTabs.Invalidate();

	return index;
}

void CTransferWnd::OnTabMovement(NMHDR *pNMHDR, LRESULT *pResult) 
{	
	UINT from=m_wndDlTabs.GetLastMovementSource();
	UINT to=m_wndDlTabs.GetLastMovementDestionation();

	if (from==0 || to==0 || from==to-1) 
		return;

	// do the reorder

	// rearrange the cat-map
	if (!theApp.glob_prefs->MoveCat(from,to)) 
		return;

	// update partfile-stored assignment
	theApp.downloadqueue->MoveCat((uint8)from,(uint8)to);

	// move category of completed files
	m_wndDownloadList.MoveCompletedfilesCat((uint8)from,(uint8)to);

	// of the tabcontrol itself
	m_wndDlTabs.ReorderTab(from,to);

	UpdateCatTabTitles();
	theApp.emuledlg->searchwnd.UpdateCatTabs();

	if (to > from) 
	{
		--to;
	}
	m_wndDlTabs.SetCurSel(to);
	m_wndDownloadList.ChangeCategory(to);
	m_wndDlTabs.Invalidate();
}

BOOL CTransferWnd::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	NMHDR* pNMHDR = (NMHDR*)lParam;
	if(pNMHDR->hwndFrom == m_wndDlTabs.GetSafeHwnd())
	{
		switch(pNMHDR->code)
		{
			case NM_RCLICK:
				OnNMRclickDltab(pNMHDR, pResult);
				break;
			case NM_DBLCLK:
			case WM_LBUTTONDBLCLK:
				OnDblclickDltab();
				break;
			case TCN_SELCHANGE:
				OnTcnSelchangeDltab(pNMHDR, pResult);
				break;
			case NM_TABMOVED:
				OnTabMovement(pNMHDR, pResult);
				break;
		}
	}
	else if(pNMHDR->hwndFrom == m_wndDownloadList.GetSafeHwnd())
	{
		switch(pNMHDR->code)
		{
			case LVN_BEGINDRAG:
				OnLvnBegindrag(pNMHDR, pResult);
				break;
		}
	}

	return CResizableDialog::OnNotify(wParam, lParam, pResult);
}
