// TrayDialog.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "TrayDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CTrayDialog dialog


CTrayDialog::CTrayDialog(UINT uIDD,CWnd* pParent /*=NULL*/)
	: CTrayDialogBase(uIDD, pParent) // #zegzav (modify)
{
	m_nidIconData.cbSize			= sizeof(NOTIFYICONDATA);
	
	m_nidIconData.hWnd				= 0;
	m_nidIconData.uID				= 1;

	m_nidIconData.uCallbackMessage	= WM_TRAY_ICON_NOTIFY_MESSAGE;

	m_nidIconData.hIcon				= 0;
	m_nidIconData.szTip[0]			= 0;	
	m_nidIconData.uFlags			= NIF_MESSAGE;

	m_bTrayIconVisible				= FALSE;
	m_bMinimizeToTray				= 0;
	m_nDefaultMenuItem				= 0;
	m_bdoubleclicked				= false;
}


const UINT WM_TASKBARCREATED = ::RegisterWindowMessage(_T("TaskbarCreated"));

BEGIN_MESSAGE_MAP(CTrayDialog, CTrayDialogBase) // #zegzav (modify)
	//{{AFX_MSG_MAP(CTrayDialog)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_TRAY_ICON_NOTIFY_MESSAGE,OnTrayNotify)
	ON_REGISTERED_MESSAGE(WM_TASKBARCREATED,OnTaskBarCreated)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrayDialog message handlers

int CTrayDialog::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CTrayDialogBase::OnCreate(lpCreateStruct) == -1) // #zegzav (modify)
		return -1;
	
	m_nidIconData.hWnd = m_hWnd;
	m_nidIconData.uID = 1;
	
	return 0;
}

void CTrayDialog::OnDestroy()
{
	CTrayDialogBase::OnDestroy();  // #zegzav (modify)
	if(m_nidIconData.hWnd && m_nidIconData.uID>0 && TrayIsVisible())
	{
		Shell_NotifyIcon(NIM_DELETE,&m_nidIconData);
	}
}

BOOL CTrayDialog::TrayIsVisible()
{
	return m_bTrayIconVisible;
}

void CTrayDialog::TraySetIcon(HICON hIcon) // #zegzav (modified)    
{
	ASSERT(hIcon); 

	//eklmn: check NULL case
	if (hIcon)
		DestroyIcon(m_nidIconData.hIcon);
	m_nidIconData.hIcon = hIcon;
	m_nidIconData.uFlags |= NIF_ICON;
}

//eklmn: removed unused functions
/*
void CTrayDialog::TraySetIcon(UINT nResourceID)
{
	ASSERT(nResourceID>0);
	HICON hIcon = AfxGetApp()->LoadIcon(nResourceID);
	
	if(hIcon)
		TraySetIcon(hIcon);
	else
		TRACE0("FAILED TO LOAD ICON\n");	
}


void CTrayDialog::TraySetIcon(LPCTSTR lpszResourceName)
{
	HICON hIcon = AfxGetApp()->LoadIcon(lpszResourceName);
	
	if(hIcon)	
		TraySetIcon(hIcon);		
	else	
		TRACE0("FAILED TO LOAD ICON\n");	
}
*/

void CTrayDialog::TraySetToolTip(LPCTSTR lpszToolTip)
{
	ASSERT(_tcslen(lpszToolTip) > 0);
	CString sToolTip(lpszToolTip);
	if(sToolTip.GetLength() >= 90)
		sToolTip = sToolTip.Left(85) + _T("...");
    _tcscpy(m_nidIconData.szTip, sToolTip);
	m_nidIconData.uFlags |= NIF_TIP;

	//if(m_bTrayIconVisible)                            // #zegzav (modified)
	//     Shell_NotifyIcon(NIM_MODIFY,&m_nidIconData); 
}

BOOL CTrayDialog::TrayShow()
{
	BOOL bSuccess = FALSE;
	if(!m_bTrayIconVisible)
	{
		bSuccess = Shell_NotifyIcon(NIM_ADD,&m_nidIconData);
		if(bSuccess)
			m_bTrayIconVisible= TRUE;
	}
	else
	{
		TRACE0("ICON ALREADY VISIBLE");
	}
	return bSuccess;
}

BOOL CTrayDialog::TrayHide()
{
	EMULE_TRY
		
	BOOL bSuccess = FALSE;
	if(m_bTrayIconVisible)
	{
		bSuccess = Shell_NotifyIcon(NIM_DELETE,&m_nidIconData);
		if(bSuccess)
		{
			m_bTrayIconVisible= FALSE;
		}
	}
	else
	{
		TRACE0("ICON ALREADY HIDDEN");
	}
	return bSuccess;
	
	EMULE_CATCH
	return false;
}

BOOL CTrayDialog::TrayUpdate()
{
	EMULE_TRY

	BOOL bSuccess = FALSE;
	if (m_bTrayIconVisible)
	{
		bSuccess = Shell_NotifyIcon(NIM_MODIFY,&m_nidIconData);
        if (!bSuccess){
            ASSERT(0);
            return FALSE;
        }
	}
	return bSuccess;

	EMULE_CATCH
	return false;
} 

BOOL CTrayDialog::TraySetMenu(UINT nResourceID,UINT nDefaultPos)
{	
	return m_mnuTrayMenu.LoadMenu(nResourceID);	
}


BOOL CTrayDialog::TraySetMenu(LPCTSTR lpszMenuName,UINT nDefaultPos)
{	
	return  m_mnuTrayMenu.LoadMenu(lpszMenuName);	
}

BOOL CTrayDialog::TraySetMenu(HMENU hMenu,UINT nDefaultPos)
{
	m_mnuTrayMenu.Attach(hMenu);
	return TRUE;
}

LRESULT CTrayDialog::OnTrayNotify(WPARAM wParam, LPARAM lParam)
{
    UINT uID; 
    UINT uMsg; 
 
    uID = (UINT) wParam; 
    uMsg = (UINT) lParam; 
 
	if (uID != 1)
		return false;
	
	CPoint pt;	

    switch (uMsg)
	{ 
		case WM_MOUSEMOVE:
			GetCursorPos(&pt);
			ClientToScreen(&pt);
			OnTrayMouseMove(pt);
			break;
		case WM_LBUTTONDOWN:
			GetCursorPos(&pt);
			ClientToScreen(&pt);
			OnTrayLButtonDown(pt);
			break;
		case WM_LBUTTONDBLCLK:
			GetCursorPos(&pt);
			ClientToScreen(&pt);
			OnTrayLButtonDblClk(pt);
			break;
		case WM_RBUTTONUP:
		case WM_CONTEXTMENU:
			GetCursorPos(&pt);
			//ClientToScreen(&pt);
			OnTrayRButtonUp(pt);//bond006: systray menu gets stuck (bugfix)
			break;
		case WM_RBUTTONDBLCLK:
			GetCursorPos(&pt);
			ClientToScreen(&pt);
			OnTrayRButtonDblClk(pt);
			break;
		case WM_LBUTTONUP:
			if(m_bdoubleclicked)
			{
				if(TrayHide())
					ShowWindow(SW_SHOW);
				m_bdoubleclicked=false;
			}
			break;
	} 
	return true; 
}

void CTrayDialog::OnSysCommand(UINT nID, LPARAM lParam)
{
	if(m_bMinimizeToTray)
	{
		if ((nID & 0xFFF0) == SC_MINIMIZE)
		{
			if(TrayShow())
				ShowWindow(SW_HIDE);
		}
		else
			CDialog::OnSysCommand(nID, lParam);	
	}
   	// #zegzav - BEGIN (add)
   	else if ((nID & 0xFFF0) == SC_MINIMIZETRAY)
   	{
       	if(TrayShow())
       		ShowWindow(SW_HIDE);
   	}
   	// #zegzav - END
	else
		CTrayDialogBase::OnSysCommand(nID, lParam); // #zegzav (modify)
}

void CTrayDialog::TraySetMinimizeToTray(int8 bMinimizeToTray)
{
	m_bMinimizeToTray = bMinimizeToTray;
}

// #zegzav - BEGIN (add)
void CTrayDialog::TrayMinimizeToTrayChanged()
{
    if (m_bMinimizeToTray)
       MinTrayBtnHide();
    else
       MinTrayBtnShow();
}
// #zegzav - ENd

void CTrayDialog::OnTrayRButtonUp(CPoint pt)
{
	//m_mnuTrayMenu.GetSubMenu(0)->TrackPopupMenu(TPM_BOTTOMALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,pt.x,pt.y,this);
	//m_mnuTrayMenu.GetSubMenu(0)->SetDefaultItem(m_nDefaultMenuItem,TRUE);
}

void CTrayDialog::OnTrayLButtonDown(CPoint pt)
{
}

void CTrayDialog::OnTrayLButtonDblClk(CPoint pt)
{
	m_bdoubleclicked=true;
}

void CTrayDialog::OnTrayRButtonDblClk(CPoint pt)
{
}

void CTrayDialog::OnTrayMouseMove(CPoint pt)
{
}

LRESULT CTrayDialog::OnTaskBarCreated(WPARAM wParam, LPARAM lParam)
{
	if(m_bTrayIconVisible)
		return Shell_NotifyIcon(NIM_ADD, &m_nidIconData);

	return true;
}
