//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#ifndef _DUMP
        #ifndef AMD
	        #define CURRENT_VERSION_LONG	_T("1h")
        #else
            #define CURRENT_VERSION_LONG	_T("1h (AMD)")
        #endif
#else
        #ifndef AMD
	        #define CURRENT_VERSION_LONG	_T("1h DEBUG")
        #else
            #define CURRENT_VERSION_LONG	_T("1h (AMD) DEBUG")
        #endif
#endif

#define PLUS_VERSION_STR "Plus 1h"
#define CURRENT_PLUS_VERSION	0x0108
#define RSAKEYSIZE				384		//384 bits

// MOD Note: Do not change this part - Merkur
#define CURRENT_VERSION_SHORT	0x30
#define CURRENT_VERSION_CHECK	0x30A
#define	EMULE_PROTOCOL			0x01
// MOD Note: end

#define	EDONKEYVERSION			0x3c
#define PREFFILE_VERSION		0x14 //<<-- last change: reduced .dat, by using .ini
#define PARTFILE_VERSION		0xe0
#define CREDITFILE_VERSION		0x12
#define CREDITFILE_VERSION_29	0x11
#define COMPILE_DATE			__DATE__
#define COMPILE_TIME			__TIME__
#ifdef _DEBUG
#define EMULE_GUID				"EMULE-{4EADC6FC-516F-4b7c-9066-97D893649569}-DEBUG"
#else
#define EMULE_GUID				"EMULE-{4EADC6FC-516F-4b7c-9066-97D893649569}"
#endif

#define	LANCASTFILEREASKTIMEUDP	10000	// LANCAST (moosetea) - File re-ask time for lan clients is 10 seconds, LAN clients never get banned
#define	LANCASTFILEREASKTIMETCP	30000	// LANCAST (moosetea) - TCP File re-ask time for lan clients is 30 seconds, this needs to be more than the UDP limit, again LAN clients never get banned

// MOD Note: Do not change this part - Merkur
#define UDPSEARCHSPEED			1000	// if this value is too low you will miss sources
#define MAX_RESULTS				100 	// max global search results
#define MAX_CLIENTCONNECTIONTRY	2
#define CONNECTION_TIMEOUT		60000	//set this lower if you want less connections at once, set it higher if you have enough sockets (edonkey has its own timout too, so a very high value won't effect this)
#define	FILEREASKTIME			1300000	//**
#define SERVERREASKTIME			800000  // don't set this too low, it wont speed up anything, but it could kill emule or your internetconnection
#define UDPSERVERREASKTIME		1300000 //***
#define SOURCECLIENTREASK		600000
#define MINCOMMONPENALTY		9
#define UDPSERVERSTATTIME		5000	//5 secs
#define UDPSERVSTATREASKTIME	14400	//4 hours
#define	UDPSERVERPORT			4665 	//default udp port
// MOD Note: end

#define MAXCONPER5SEC			theApp.glob_prefs->GetMaxConPerSec()
#define RARE_FILE				25  	// Sources to consider a rare file * DO NOT TOUCH *

#define	SEC2MS(sec)		((sec)*1000)
#define	MIN2MS(min)		SEC2MS((min)*60)


#define	UPLOAD_LOW_CLIENT_DR	2400 // uploadspeed per client in bytes - you may want to adjust this if you have a slow connection or T1-T3 ;)
#define	UPLOAD_CLIENT_DATARATE 	3200
#define	MIN_UP_CLIENTS_ALLOWED 	2
#define	MAX_UP_CLIENTS_ALLOWED 	100

#define	UPLOAD_CLIENT_THRESHOLD 5000	// minimum time between starting new uploads
#define MAX_LINES_IN_LOGVIEW	1000	// limit the number of lines shown in the server/log view of the mule

#define DOWNLOADTIMEOUT			100000
#define CONSERVTIMEOUT			theApp.glob_prefs->SrvConTimeout() //agelimit for pending connection attempts
#define BADCLIENTBAN 			theApp.glob_prefs->BadClientMinRequestNum()
#define	MIN_REQUESTTIME 		theApp.glob_prefs->BadClientMinRequestTime()
#define	MAX_PURGEQUEUETIME		7200000 //Vorlost doubled clear dead clients timeout
#define CONNECTION_LATENCY		22050 //latency for responses
#define	SOURCESSLOTS			100
#define MINWAIT_BEFORE_DLDISPLAY_WINDOWUPDATE   1000
#define MINWAIT_BEFORE_ULDISPLAY_WINDOWUPDATE   3000
#define MINWAIT_BEFORE_CALCULATE_DL_RATE        1000

#define ASK_FOR_PARTS_ON_UPLOAD theApp.glob_prefs->IsUploadPartsEnabled() // 0 disabled - 1 enabled

// you shouldn't change anything here if you are not really sure, or emule will probaly not work
#define	MAXFRAGSIZE				1300
#define	PARTSIZE				9728000
#define EMBLOCKSIZE				184320
#define MINFIRSTMOVIESIZE		1216000   //Vorlost for LoadRarestFinishedChunks Patch2
#define MINLASTMOVIESIZE		1216000   //= 1/8 of PARTSIZE, less possible... [Vorlost]
#define OP_EDONKEYHEADER		0xE3
#define OP_EDONKEYPROT			OP_EDONKEYHEADER
#define OP_PACKEDPROT			0xD4
#define OP_EMULEPROT			0xC5
#define OP_MLDONKEYPROT			0x00
#define	MET_HEADER				0x0E

#define UNLIMITED				0xFFFF

// client <-> server
#define OP_LOGINREQUEST			0x01	//<HASH 16><ID 4><PORT 2><1 Tag_set>
#define OP_REJECT				0x05	//(null)
#define OP_GETSERVERLIST		0x14	//(null)client->server
#define	OP_OFFERFILES			0x15	// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
#define OP_SEARCHREQUEST		0x16	// <Query_Tree>
#define OP_DISCONNECT			0x18	// (not verified)
#define OP_GETSOURCES			0x19	// <HASH 16>
#define	OP_SEARCH_USER			0x1A	// <Query_Tree>
#define OP_CALLBACKREQUEST		0x1C	// <ID 4>
#define	OP_QUERY_CHATS			0x1D	// (deprecated not supported by server any longer)
#define OP_CHAT_MESSAGE        	0x1E    // (deprecated not supported by server any longer)
#define OP_JOIN_ROOM            0x1F    // (deprecated not supported by server any longer)
#define OP_QUERY_MORE_RESULT    0x21    // (null)
#define OP_SERVERLIST			0x32	// <count 1>(<IP 4><PORT 2>)[count] server->client
#define OP_SEARCHRESULT			0x33	// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
#define	OP_SERVERSTATUS			0x34	// <USER 4><FILES 4>
#define OP_CALLBACKREQUESTED	0x35	// <IP 4><PORT 2>
#define OP_CALLBACK_FAIL		0x36	// (null notverified)
#define OP_SERVERMESSAGE		0x38	// <len 2><Message len>
#define OP_CHAT_ROOM_REQUEST    0x39    // (deprecated not supported by server any longer)
#define OP_CHAT_BROADCAST       0x3A    // (deprecated not supported by server any longer)
#define OP_CHAT_USER_JOIN       0x3B    // (deprecated not supported by server any longer)
#define OP_CHAT_USER_LEAVE      0x3C    // (deprecated not supported by server any longer)
#define OP_CHAT_USER            0x3D    // (deprecated not supported by server any longer)
#define OP_IDCHANGE				0x40	// <NEW_ID 4>
#define OP_SERVERIDENT     		0x41	// <HASH 16><IP 4><PORT 2>{1 TAG_SET}
#define OP_FOUNDSOURCES			0x42	// <HASH 16><count 1>(<ID 4><PORT 2>)[count]
#define OP_USERS_LIST           0x43    // <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]

//client <-> UDP server
#define OP_GLOBSERVSTATREQ		0x96	// (null)
#define	OP_GLOBSERVSTATRES		0x97	// <USER 4><FILES 4>
#define OP_GLOBSEARCHREQ		0x98	// <search_tree>
#define OP_GLOBSEARCHRES		0x99	//
#define OP_GLOBGETSOURCES		0x9A	// <HASH 16>
#define OP_GLOBFOUNDSOURCES		0x9B	//
#define OP_GLOBCALLBACKREQ		0x9C	// <ID 4>
#define	OP_SERVER_LIST_REQ		0xA0	// <IP 4><PORT 2>
#define OP_SERVER_LIST_RES		0xA1	// <count 1> (<ip 4><port 2>)[count]
#define OP_SERVER_DESC_REQ		0xA2	// (null)
#define OP_SERVER_DESC_RES		0xA3	// <name_len 2><name name_len><desc_len 2 desc_en>
#define OP_SERVER_LIST_REQ2		0xA4	// (null)

// client <-> client
#define	OP_HELLO				0x01	// 0x10<HASH 16><ID 4><PORT 2><1 Tag_set>
#define OP_SENDINGPART			0x46	// <HASH 16><von 4><bis 4><Daten len:(von-bis)>
#define	OP_REQUESTPARTS			0x47	// <HASH 16><von[3] 4*3><bis[3] 4*3>
#define OP_FILEREQANSNOFIL		0x48	// <HASH 16>
#define OP_END_OF_DOWNLOAD     	0x49    // <HASH 16>
#define OP_ASKSHAREDFILES		0x4A	// (null)
#define OP_ASKSHAREDFILESANSWER 0x4B	// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
#define	OP_HELLOANSWER			0x4C	// <HASH 16><ID 4><PORT 2><1 Tag_set><SERVER_IP 4><SERVER_PORT 2>
#define OP_CHANGE_CLIENT_ID 	0x4D	// <ID_old 4><ID_new 4>
#define	OP_MESSAGE				0x4E	// <len 2><Message len>
#define OP_SETREQFILEID			0x4F	// <HASH 16>
#define	OP_FILESTATUS			0x50	// <HASH 16><count 2><status(bit array) len:((count+7)/8)>
#define OP_HASHSETREQUEST		0x51	// <HASH 16>
#define OP_HASHSETANSWER		0x52	// <count 2><HASH[count] 16*count>
#define	OP_STARTUPLOADREQ		0x54	// <HASH 16>
#define	OP_ACCEPTUPLOADREQ		0x55	// (null)
#define	OP_CANCELTRANSFER		0x56	// (null)
#define OP_OUTOFPARTREQS		0x57	// (null)
#define OP_FILEREQUEST			0x58	// <HASH 16>	(more correctly file_name_request)
#define OP_FILEREQANSWER		0x59	// <HASH 16><len 4><NAME len>
#define OP_CHANGE_SLOT			0x5B	// <HASH 16>
#define OP_QUEUERANK			0x5C	// <wert  4> (slot index of the request)
#define OP_ASKSHAREDDIRS        0x5D    // (null)
#define OP_ASKSHAREDFILESDIR    0x5E    // <len 2><Directory len>
#define OP_ASKSHAREDDIRSANS     0x5F    // <count 4>(<len 2><Directory len>)[count]
#define OP_ASKSHAREDFILESDIRANS 0x60    // <len 2><Directory len><count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
#define OP_ASKSHAREDDENIEDANS   0x61    // (null)

#define OP_UNKNOWNx6A			0x6A	// ??? Hybrid v49,4 (Horde?)
#define OP_UNKNOWNx7A			0x7A	// ??? size: 2 data: 00 d2

// extened prot client <-> extened prot client
#define	OP_EMULEINFO			0x01	//
#define	OP_EMULEINFOANSWER		0x02	//
#define OP_COMPRESSEDPART		0x40	//
#define OP_QUEUERANKING			0x60	// <RANG 2>
#define OP_FILEDESC			0x61	// <len 2><NAME len>
#define OP_VERIFYUPSREQ			0x71	// (never used)
#define OP_VERIFYUPSANSWER		0x72	// (never used)
#define OP_UDPVERIFYUPREQ		0x73	// (never used)
#define OP_UDPVERIFYUPA			0x74	// (never used)
#define OP_REQUESTSOURCES		0x81	// <HASH 16>
#define OP_ANSWERSOURCES		0x82	//
#define OP_PUBLICKEY			0x85	// <len 1><pubkey len>
#define OP_SIGNATURE			0x86	// v1: <len 1><signature len>  v2:<len 1><signature len><sigIPused 1>
#define OP_SECIDENTSTATE		0x87	// <state 1><rndchallenge 4>

// extened prot client <-> extened prot client UDP
#define OP_REASKFILEPING		0x90	// <HASH 16>
#define OP_REASKACK				0x91	// <HASH 16>
#define OP_FILENOTFOUND			0x92
#define OP_QUEUEFULL			0x93

// server tags
#define ST_SERVERNAME			0x01	// <string>
#define ST_DESCRIPTION			0x0B	// <string>
#define ST_PING					0x0C	// <int>
#define ST_PREFERENCE			0x0E	// <int>
#define ST_FAIL					0x0D	// <int>
#define	ST_DYNIP				0x85
//#define ST_LASTPING			0x86	// <int> No longer used.
#define ST_MAXUSERS				0x87
#define ST_SOFTFILES			0x88
#define ST_HARDFILES			0x89
#define ST_LASTPING				0x90	// <int>
#define	ST_VERSION				0x91	// <string>

//file tags
#define FT_FILENAME				0x01
#define FT_FILESIZE				0x02	// <int>
#define FT_FILETYPE				0x03	// <string>
#define FT_FILEFORMAT			0x04	// <string>
#define FT_LASTSEENCOMPLETE		0x05

#define FT_TRANSFERED			0x08	// <int>
#define FT_GAPSTART				0x09
#define FT_GAPEND				0x0A
#define FT_PARTFILENAME			0x12	// <string>
#define FT_PRIORITY				0x13
#define FT_STATUS				0x14
#define FT_SOURCES				0x15
#define FT_PERMISSIONS			0x16
#define FT_ULPRIORITY			0x17
//#define FT_DLPRIORITY			0x18	// Was 13
//#define FT_ULPRIORITY			0x19	// Was 17
#define FT_CATEGORY				0x20

// statistic
#define FT_ATTRANSFERED			0x50
#define FT_ATREQUESTED			0x51
#define FT_ATACCEPTED			0x52

// client tags, ed2k-prot OP_HELLO
#define CT_NAME					0x01
#define CT_VERSION				0x11
#define	CT_PORT					0x0f
#define CT_FRIENDSHARING		0x66 //[Bloodymad@Vorlost Anti-Friendsharing 0.3]

// unknown client tags (friendsharing, DarkMule, ...)
#define CT_UNKNOWNx0				0x0  // Hybrid Horde protocol
#define CT_UNKNOWNx12				0x12 // http://www.haspepapa-welt.de (DodgeBoards)
#define CT_UNKNOWNx13				0x13 // http://www.haspepapa-welt.de (DodgeBoards)
#define CT_UNKNOWNx14				0x14 // http://www.haspepapa-welt.de (DodgeBoards)
#define CT_UNKNOWNx15				0x15 // http://www.haspepapa-welt.de (DodgeBoards) & DarkMule |eVorte|X|
#define CT_UNKNOWNx16				0x16 // http://www.haspepapa-welt.de (DodgeBoards)
#define CT_UNKNOWNx17				0x17 // http://www.haspepapa-welt.de (DodgeBoards)
#define CT_UNKNOWNx22				0x22 // DarkMule |eVorte|X|
#define CT_UNKNOWNx63				0x63 // ?
#define CT_UNKNOWNx64				0x64 // ?
#define CT_UNKNOWNx69				0x69 // DarkMule v6 |eVorte|X|
#define CT_UNKNOWNx88				0x88 // DarkMule v6 |eVorte|X|
#define CT_UNKNOWNx8c				0x8c // eMule v0.27c [LSD7c] 
#define CT_UNKNOWNx8d				0x8d // unknown Leecher - (client version:60)
#define CT_UNKNOWNx99				0x99 // eMule v0.26d [RAMMSTEIN 8b]

// emule tags, emule-extend-prot OP_EMULEINFO
#define ET_COMPRESSION				0x20
#define ET_UDPPORT					0x21 
#define ET_UDPVER					0x22
#define ET_SOURCEEXCHANGE			0x23
#define ET_COMMENTS					0x24
#define ET_EXTENDEDREQUEST			0x25
#define ET_COMPATABLECLIENT			0x26
#define ET_FEATURES					0x27	// secure credits (official 0.29b)

#define ET_INCOMPLETEPARTS			0x3D //<<-- enkeyDEV(th1) -ICS-
#define ET_L2HAC					0x3E //<<-- enkeyDEV(th1) -L2HAC-

// mod tags
#define ET_MOD_FEATURESET			0x54 //[Bloodymad Featureset]
#define ET_MOD_VERSION				0x55 // Mod ver Generic String
#define ET_MOD_PROTOCOL				0x56 // Mod ver Extended Mod Protocol
#define ET_MOD_PLUS				    0x99 //to avoid conflicts with ET_TAROD_VERSION recognized by lugdunum srvers

// identified MOD's 
#define ET_MOD_BOWLFISH             0x5A	
#define ET_MOD_FUSION				0x66
#define ET_MOD_FUSION_VERSION       0x67
#define ET_MOD_TAROD				0x77
#define ET_MOD_TAROD_VERSION		0x78
#define ET_MOD_Morph                0x79
#define ET_MOD_Morph_VERSION	    0x80
#define ET_MOD_MorTillo				0x82
#define ET_MOD_MorTillo_VERSION		0x83 
#define ET_MOD_LSD				    0x87  
#define ET_MOD_LSD_VERSION		    0x88
#define ET_MOD_LOVELACE_VERSION		0x90
#define ET_MOD_OXY                  0x94

// unknown eMule tags
#define ET_MOD_UNKNOWNx12			0x12 // http://www.haspepapa-welt.de
#define ET_MOD_UNKNOWNx13			0x13 // http://www.haspepapa-welt.de
#define ET_MOD_UNKNOWNx14			0x14 // http://www.haspepapa-welt.de
#define ET_MOD_UNKNOWNx17			0x17 // http://www.haspepapa-welt.de
#define ET_MOD_UNKNOWNx41			0x41 // CrewMod (pre-release mod based on Plus) identification
#define ET_MOD_UNKNOWNx42			0x42 // CrewMod (pre-release mod based on Plus) key verification
#define ET_MOD_UNKNOWNx43			0x43 // CrewMod (pre-release mod based on Plus) version info
#define ET_MOD_UNKNOWNx5C			0x5C // LSD-MOD
#define ET_MOD_UNKNOWNx64			0x64 // LSD.9dT / Athlazan(0.29c)Alpha.3
#define ET_MOD_UNKNOWNx76			0x76 // http://www.haspepapa-welt.de (DodgeBoards)
#define ET_MOD_UNKNOWNx85			0x85 // ? 
#define ET_MOD_UNKNOWNx86			0x86 // ? 
#define ET_MOD_UNKNOWNx91			0x91 // DarkMule v6 |eVorte|X|
#define ET_MOD_UNKNOWNx92			0x92 // DarkMule v6 |eVorte|X|
#define ET_MOD_UNKNOWNx93			0x93 // ?
#define ET_MOD_UNKNOWNxA0			0xA0 // --CeeK--(eMule v0.28)
#define ET_MOD_UNKNOWNxDA			0xDA // Rumata (rus)(Plus v1f) - leecher mod?

// [Bloodymad Featureset
// [bloodymad] Sends as QR a estimated waiting time
#define EF_SENDSWAITTIME		0x00000001	// not used by emuleplus
// end mod tags

#define MP_MESSAGE				10102
#define MP_DETAIL				10103
#define MP_ADDFRIEND			10104
#define MP_REMOVEFRIEND			10105
#define MP_SHOWLIST				10106
#define MP_FRIENDSLOT			10107 
#define MP_CANCEL				10201
#define MP_STOP					10202
#define MP_RESUME				10204
#define MP_PAUSE				10203
#define	MP_CLEARCOMPLETED		10205
#define	MP_OPEN					10206
#define	MP_PREVIEW				10207
#define MP_DOWNNOW				10211 // A4AF Amdribant
#define MP_OPENFOLDER 			10214 // reCDVst
#define MP_CUSTOMIZETOOLBAR		10215 // reCDVst
#define MP_SELECTTOOLBARBITMAPDIR 10216 // reCDVst
#define MP_SELECTTOOLBARBITMAP	10217 // reCDVst
#define MP_NOTEXTLABELS			10218
#define MP_TEXTLABELS			10219
#define MP_TEXTLABELSONRIGHT	10220
#define MP_TOOLBARBITMAP		10221 // reCDVst
#define MP_CHANGEDIR			10222 //<<-- enkeyDEV(Ottavio84) -ChangeDir-
#define MP_SHELLCONTEXT			10223
#define MP_DOCLEANUP			10224 //SyruS: cleanup

//For comments 
#define MP_CMT              	10400
#define MP_SWITCHCTRL			10401

#define MP_PRIOVERYLOW			10300
#define MP_PRIOLOW				10301
#define MP_PRIONORMAL			10302
#define MP_PRIOHIGH				10303
#define MP_PRIOAUTO				10404 // Tarod
#define MP_PRIOVERYHIGH			10304
#define MP_GETED2KLINK			10305
#define MP_GETHTMLED2KLINK		10306
#define	MP_GETSOURCEED2KLINK 	10299
#define MP_METINFO				10307
#define MP_PERMALL				10308
#define MP_PERMFRIENDS			10309
#define MP_PERMNONE				10310
#define MP_CONNECTTO			10311
#define MP_REMOVE				10312
#define MP_REMOVEALL			10313
#define MP_REMOVESELECTED		10314
#define MP_UNBAN				10315
#define MP_ADDTOSTATIC			10316
#define MP_CLCOMMAND			10317
#define MP_CAT_ADD				10321
#define MP_CAT_EDIT				10322
#define MP_CAT_REMOVE			10323
#define MP_RESUMENEXT			10324
#define MPG_DELETE				10325
#define MPG_ALTENTER			10330
#define MP_REMOVEFROMSTATIC		10402
#define MP_VIEWFILECOMMENTS 	10403
#define MP_WEBURL				10700 //japg2000 (+256 BEWARE: taking up to 10956)

//--- xrmb:partTraffic ---
#define MP_SFL_CLEARSTATS		10600
#define MP_SFL_CLEARALLSTATS	10601
//--- :xrmb ---
//--- xrmb:allyaknow ---
#define MP_SFL_ALLYAKNOW		10610
#define MP_SFL_MERGEKNOWN		10611
#define MP_SFL_DELKNOWN			10612
//--- :xrmb ---
//--- xrmb:partprio ---
#define MP_SFL_PARTON			10621
#define MP_SFL_PARTOFF			10622
#define MP_SFL_PARTHIDDEN		10623
//--- :xrmb ---

#define Irc_Version				"(SMIRCv00.65)"
#define Irc_Op					10240
#define Irc_DeOp				10241
#define Irc_Voice				10242
#define Irc_DeVoice				10243
#define Irc_HalfOp				10244
#define Irc_DeHalfOp			10245
#define Irc_Kick				10246
#define Irc_Slap				10247
#define Irc_Join				10248
#define Irc_Close				10249
#define Irc_Priv				10250
#define Irc_AddFriend			10251
#define	Irc_SendLink			10252
#define Irc_SetSendLink			10253
#define	Irc_Owner				10254
#define Irc_DeOwner				10255
#define	Irc_Protect				10256
#define Irc_DeProtect			10257

// emuleapp <-> emuleapp
#define OP_ED2KLINK				12000
#define OP_CLCOMMAND		    12001

//thread messages
#define	TM_FINISHEDHASHING		(WM_APP+10)
#define TM_HASHTHREADFINISHED	(WM_APP+20)
#define TM_SOURCEHOSTNAMERESOLVED (WM_APP+1450)

/*// Quick Speed Changer [Jmpep]
#define MP_QS_U10				10501
#define MP_QS_U20				10502
#define MP_QS_U30				10503
#define MP_QS_U40				10504
#define MP_QS_U50				10505
#define MP_QS_U60				10506
#define MP_QS_U70				10507
#define MP_QS_U80				10508
#define MP_QS_U90				10509
#define MP_QS_U100				10510
#define MP_QS_UPC				10511
#define MP_QS_UP10				10512
#define MP_QS_UPL				10513
#define MP_QS_D10				10521
#define MP_QS_D20				10522
#define MP_QS_D30				10523
#define MP_QS_D40				10524
#define MP_QS_D50				10525
#define MP_QS_D60				10526
#define MP_QS_D70				10527
#define MP_QS_D80				10528
#define MP_QS_D90				10529
#define MP_QS_D100				10530
#define MP_QS_DC				10531
#define MP_QS_DL				10532
*/
#define MP_QS_PA				10533
#define MP_QS_UA				10534

#define MP_ASSIGNCAT			11100
// reserve some for categories!
#define MP_CAT_SET0				11101
// reserve some for change all-cats (about 20)

//Proxytypes
#define PROXYTYPE_NOPROXY 0
#define PROXYTYPE_SOCKS4 1
#define PROXYTYPE_SOCKS4A 2
#define PROXYTYPE_SOCKS5 3
#define PROXYTYPE_HTTP11 4

#define MP_ASK_FOR_FILES		11002
#define MP_ALL_A4AF_TO_HERE		11003
#define MP_DROPNONEEDEDSRCS		11004
#define MP_ALL_A4AF_AUTO		11005
#define MP_MOVIE				11006
#define MP_DROP_SUPERCOMPRESSED	11007

#define PURGE_TIME				30000	// purge time for no needed parts sources
#define MAX_QUEUE				10000
#define MIN_QUEUE				1000

//kuchin/purity
#define WEB_CONNECT_TO_SERVER	WM_USER + 7001
#define WEB_REMOVE_SERVER		WM_USER + 7002
#define WEB_SHARED_FILES_RELOAD	WM_USER + 7003
#define WEB_ADD_TO_STATIC		WM_USER + 7004
#define WEB_REMOVE_FROM_STATIC	WM_USER + 7005

// netwolf: ottavios SLS
#define EXPIREIN					theApp.glob_prefs->WhenSourcesOutdated()
#define RELOADTIME					theApp.glob_prefs->RestoreSourcesTime()
#define RESAVETIME					600000 //10 minutes

//--- xrmb:partprio ---
//--- moved from partfile.h ---
#define PR_VERYLOW			4 // I Had to change this because it didn't save negative number correctly.. Had to modify the sort function for this change..
#define SRV_PR_LOW			2
#define PR_LOW				0 //*
#define PR_NORMAL			1 // Don't change this - needed for edonkey clients and server!
#define SRV_PR_NORMAL		0
#define	PR_HIGH				2 //*
#define SRV_PR_HIGH			1
#define PR_VERYHIGH			3
#define PR_AUTO				5 //UAP Hunter
#if JUMPSTART
	#define PR_JUMPSTART	6
#endif

#define PR_PART_ON 			0
#define PR_PART_HIDDEN		1
#define PR_PART_OFF			2
//--- :xrmb ---

// START enkeyDEV(th1) -L2HAC-
#define L2HAC_DEFAULT_EMULE		(FILEREASKTIME)
#define L2HAC_MIN_TIME			900000
#define L2HAC_MAX_TIME			3600000
#define L2HAC_CALLBACK_PRECEDE	(CONNECTION_TIMEOUT >> 1)
#define L2HAC_PREPARE_PRECEDE	(CONNECTION_TIMEOUT)
// END enkeyDEV(th1) -L2HAC-

//eklmn: statistic section
#define STATS_DL_SOURCES_TYPE		19
#define STATS_DL_DATA_INFO			7
//average calculation
#define AVG_SESSION					0
#define AVG_TIME					1
#define AVG_TOTAL					2	// -khaos--+++> For the total average
