//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#include "stdafx.h"
#include "emule.h"
#include "packets.h"
#include "sockets.h"
#include "emuleDlg.h"
#include "opcodes.h"
#include "searchlist.h"
#include <time.h>
#include <afxmt.h>
#include <afxinet.h>
#include "UDPSocket.h"
#include "Smtp.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/*
static TCHAR g_Urls[7][50] = {
	_T("www.microsoft.com"),
	_T("www.yahoo.com"),
	_T("www.ibm.com"),
	_T("www.army.mil"),
	_T("www.networksolutions.com"),
	_T("www.ripe.net"),
	_T("www.w3.org")
};
*/

#ifdef OLD_SOCKETS_ENABLED

// CServerConnect

void CServerConnect::TryAnotherConnectionrequest()
{
  EMULE_TRY
  	//eklmn: change funny condition :) (connectionattemps.GetCount() < ((app_prefs->IsSafeConnectEnabled()) ? 1 : 2))
	if ( connectionattemps.GetCount() == 0)
	{
		CServer*  next_server = used_list->GetNextServer();

		if (!next_server)
		{
			if (connectionattemps.GetCount()==0){
				AddLogLine(true,IDS_OUTOFSERVERS);
				ConnectToAnyServer(lastStartAt,false);
			}
			return;
		}

		// Barry - Only auto-connect to static server option
		if (theApp.glob_prefs->AutoConnectStaticOnly())
		{
			if (next_server->IsStaticMember())
				ConnectToServer(*next_server);
		}
		else
			ConnectToServer(*next_server);
	}
  EMULE_CATCH
}

void CServerConnect::ConnectToAnyServer(uint32 startAt,bool prioSort,bool isAuto)
{
  EMULE_TRY

 	CServer *next_server; 
  	if (startAt == 0xFFFFFFFF)
		startAt = used_list->GetServerPostion();
	lastStartAt=startAt;
  
	StopConnectionTry();
	Disconnect();
	
	theApp.emuledlg->ShowConnectionState(false,_T(""),true);
	// connectig will be set to true only when socket will be created
	//connecting = true;
	// eklmn: check size of the list
	if (used_list->GetServerCount()==0 )
	{
		//connecting = false;
		AddLogLine(true,IDS_ERR_NOVALIDSERVERSFOUND);
		return;
	}
	// eklmn: now sort the list
	if( theApp.glob_prefs->Score() && prioSort ) used_list->Sort();
	// Barry - Only auto-connect to static server option
	if (theApp.glob_prefs->AutoConnectStaticOnly() && isAuto)
	{
		bool anystatic = false;
		used_list->SetServerPosition( startAt );
		//eklmn: scan all servers in the list
		for (uint32 i=0; i<used_list->GetServerCount();i++)		//while ((next_server = used_list->GetNextServer()) != NULL)
		{
			next_server = used_list->GetNextServer();
			if (next_server->IsStaticMember())
			{
				anystatic = true;
				break;
			}
		}
		if (!anystatic)
		{
			//connecting = false;
			AddLogLine(true,IDS_ERR_NOVALIDSERVERSFOUND);
			return;
		}
	}
	else		// eklmn: just pick up new server
	{
		used_list->SetServerPosition( startAt );
		next_server = used_list->GetServerAt(startAt);
		// eklmn: if we are in the end of serverlist, we gonna to become next_server = NULL.
		// since list has at least one srever, we just need to repeat operation
		if (next_server == NULL)
			next_server = used_list->GetNextServer();
	}
	theApp.listensocket->Process();

	// at this point we have a server object "next_server" let's connect to him
	if (next_server != NULL)
		ConnectToServer(*next_server);
	//TryAnotherConnectionrequest();
  EMULE_CATCH
}

void CServerConnect::ConnectToServer(CServer& server)
{
	EMULE_TRY
		
	StopConnectionTry();
	Disconnect();
	
	ConnectingToServer = &server;	//purity (Server status in WebServer)

	CServerSocket* newsocket = new CServerSocket(this);
	if (newsocket) {
		//AddDebugLogLine(false, "-server->: Socket was created (connecting = true). ");
		connecting = true;
		m_lstOpenSockets.AddTail(newsocket);
		newsocket->Create(0,SOCK_STREAM,FD_READ|FD_WRITE|FD_CLOSE|FD_CONNECT,NULL);
		newsocket->ConnectToServer(server);
		ULONG x=GetTickCount();
		connectionattemps.SetAt(x,newsocket);
	}
	EMULE_CATCH
}

void CServerConnect::StopConnectionTry()
{
  EMULE_TRY
	connectionattemps.RemoveAll();
	connecting = false;

	if (m_idRetryTimer) 
	{ 
		KillTimer(NULL, m_idRetryTimer); 
		m_idRetryTimer= 0; 
	} 

	// close all currenty opened sockets except the one which is connected to our current server
	POSITION pos1, pos2;
	for(pos1 = m_lstOpenSockets.GetHeadPosition(); ( pos2 = pos1 ) != NULL; )
	{
	
		CServerSocket* pSck = m_lstOpenSockets.GetNext(pos1);
		// don't destroy socket which is connected to server
		// don't destroy socket if it is going to destroy itself later on
		if (pSck != connectedsocket)
			DestroySocket(pSck);
		/*
		if ((pSck != NULL) && (pSck != connectedsocket))	
		{			
			m_lstOpenSockets.RemoveAt(pos2);

			if (pSck->m_SocketData.hSocket != INVALID_SOCKET){ // deadlake PROXYSUPPORT - changed to AsyncSocketEx
				pSck->AsyncSelect(0);
				pSck->Close();
			}
			delete pSck;
		}
		*/
	}
  EMULE_CATCH
}

void CServerConnect::ConnectionEstablished(CServerSocket* sender)
{
  EMULE_TRY
	m_nConnectionAttempts = 0;
	if(m_idCheckTimer)
	  	KillTimer(NULL, m_idCheckTimer);
	m_idCheckTimer = 0;

	if (connecting == false)
	{
		// we are already connected to another server
		DestroySocket(sender);
		return;
	}
	InitLocalIP();
	if (sender->GetConnectionState() == CS_WAITFORLOGIN){
		//Cax2 - reset the timeout timer
		ULONG tmpkey;
		CServerSocket* tmpsock;
		POSITION pos = connectionattemps.GetStartPosition();
		while (pos)
		{
			connectionattemps.GetNextAssoc(pos,tmpkey,tmpsock);
			if (tmpsock==sender)
			{
				connectionattemps.RemoveKey(tmpkey);
				tmpkey=GetTickCount();
				connectionattemps.SetAt(tmpkey,sender);
				break;
			}
		}
		//Cax2 - end reset the timeout timer
		AddLogLine(false,IDS_CONNECTEDTOREQ,sender->cur_server->GetListName(),sender->cur_server->GetFullIP(),sender->cur_server->GetPort());
		//send loginpacket
		CServer* update = theApp.serverlist->GetServerByAddress( sender->cur_server->GetAddress(), sender->cur_server->GetPort() );
		if (update){
			update->ResetFailedCount();
			theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*update );
		}
		CMemFile data;
		data.Write(theApp.glob_prefs->GetUserHash(),16);
		uint32 clientid = GetClientID();
		data.Write(&clientid,4);
		uint16 port = app_prefs->GetPort();
		data.Write(&port,2);
		uint32 tagcount = 3;
		data.Write(&tagcount,4);
		CTag* tag = new CTag(CT_NAME,app_prefs->GetUserNick().GetBuffer());
		tag->WriteTagToFile(data);
		delete tag;
		tag = new CTag(CT_VERSION,EDONKEYVERSION);
		tag->WriteTagToFile(data);
		delete tag;
		tag = new CTag(CT_PORT,app_prefs->GetPort());
		tag->WriteTagToFile(data);
		delete tag;

		Packet* packet = new Packet(&data);
		packet->opcode = OP_LOGINREQUEST;
		theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
		this->SendPacket(packet,true,sender);		
	}
	else if (sender->GetConnectionState() == CS_CONNECTED){	
		theApp.stat_reconnects++;
		theApp.stat_serverConnectTime=GetTickCount();
		connected = true;
		AddLogLine(true,IDS_CONNECTEDTO,sender->cur_server->GetListName());
		theApp.emuledlg->ShowConnectionState(true,sender->cur_server->GetListName());
		connectedsocket = sender;
		StopConnectionTry();
		theApp.sharedfiles->SendListToServer();
		theApp.emuledlg->serverwnd.serverlistctrl.RemoveDeadServer();
		// tecxx 1609 2002 - serverlist update
		if (theApp.glob_prefs->GetAddServersFromConn())
		{
			Packet* packet = new Packet(OP_GETSERVERLIST,0);
			theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
			SendPacket(packet,true);
		}
		if(theApp.glob_prefs->RestartWaiting())
			theApp.emuledlg->transferwnd.m_wndDownloadList.RestartWaitingDownloads();
	}
  EMULE_CATCH
}

bool CServerConnect::SendPacket(Packet* packet,bool delpacket, CServerSocket* to)
{
	EMULE_TRY
	if (!to){
		if (connected){
			connectedsocket->SendPacket(packet,delpacket,true);
		}
		else{
      		if (delpacket)
        	delete packet;
			return false;
		}
	}
	else{
		to->SendPacket(packet,delpacket,true);
	}
	return true;
	EMULE_CATCH
	return false;
}

bool CServerConnect::SendUDPPacket(Packet* packet,CServer* host,bool delpacket)
{
	EMULE_TRY
		if (connected && (host != NULL)){
			udpsocket->SendPacket(packet,host);
		}
		if (delpacket)
			delete packet;
	return true;
	EMULE_CATCH
	return false;
}

void CServerConnect::ConnectionFailed(CServerSocket* sender)
{
	EMULE_TRY
	if (connecting == false && sender != connectedsocket)
	{
		// just return, cleanup is done by the socket itself
		return;
	}
	//messages + fail tries count
	CServer* update;
	switch (sender->GetConnectionState())
	{
		case CS_FATALERROR:
			// Purity - Sending message when internet connection down
			{ CString MessageText; 
			MessageText.Format(GetResString(IDS_ERR_FATAL));
			theApp.smtpconnection->SendMail(MessageText, theApp.glob_prefs->GetNotifierPopOnServerError(), theApp.glob_prefs->IsSMTPWarningEnabled());
			theApp.emuledlg->ShowNotifier(MessageText, TBN_SERVER, false, theApp.glob_prefs->GetNotifierPopOnServerError()); }
			AddLogLine(true,IDS_ERR_FATAL);
			m_nConnectionAttempts++;
			break;
		case CS_DISCONNECTED:
			// Purity - Sending message when connection lost to server
			{ CString MessageText;
			MessageText.Format(GetResString(IDS_ERR_LOSTC),sender->cur_server->GetListName(),sender->cur_server->GetFullIP(),sender->cur_server->GetPort());
			theApp.smtpconnection->SendMail(MessageText, theApp.glob_prefs->GetNotifierPopOnServerError(), theApp.glob_prefs->IsSMTPInfoEnabled());
			theApp.emuledlg->ShowNotifier(MessageText, TBN_SERVER, false, theApp.glob_prefs->GetNotifierPopOnServerError()); }
			theApp.emuledlg->sharedfileswnd.sharedfilesctrl.UpdateOfferedItems();	// refresh offered files
			AddLogLine(true,IDS_ERR_LOSTC,sender->cur_server->GetListName(),sender->cur_server->GetFullIP(),sender->cur_server->GetPort());
			break;
		case CS_SERVERDEAD:
			AddLogLine(false,IDS_ERR_DEAD,sender->cur_server->GetListName(),sender->cur_server->GetFullIP(),sender->cur_server->GetPort()); //<<--
			update = theApp.serverlist->GetServerByAddress( sender->cur_server->GetAddress(), sender->cur_server->GetPort() );
			if(update){
				update->AddFailedCount();
				theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*update );
			}
			m_nConnectionAttempts++;
			break;
		case CS_ERROR:
			m_nConnectionAttempts++;
			break;
		case CS_SERVERFULL:
			AddLogLine(false,IDS_ERR_FULL,sender->cur_server->GetListName(),sender->cur_server->GetFullIP(),sender->cur_server->GetPort());
			break;
		case CS_NOTCONNECTED: 
			m_nConnectionAttempts++;
			break; 
	}

	if(m_nConnectionAttempts >= 3)
	{
		if(!m_idCheckTimer)
		{
			CString sUrl;
			sUrl.Format(_T("http://%s"), theApp.g_Urls[rand() % theApp.g_Urls.GetSize()]);

			CString message = GetResString(IDS_NET_CHECKING) + " [" + sUrl + "]";

			AddLogLine(false, message);

			if(IsAliveURL(sUrl))
			{
				AddLogLine(false,IDS_NET_WORKING);
				m_nConnectionAttempts = 0;
			}
			else
			{
				AddLogLine(false,IDS_ERR_FATAL);
				StopConnectionTry();
				m_idCheckTimer = SetTimer(NULL, 0, 1000*CS_RETRYCONNECTTIME, (TIMERPROC)CheckInternetCallback);
				return;
			}
		}
	}

	switch (sender->GetConnectionState())
	{
		case CS_FATALERROR:{
			StopConnectionTry();
			if ((app_prefs->Reconnect()) && (!m_idRetryTimer)){ 
   				// Purity - Sending message when reconnecting after 30 seconds
				CString MessageText;
				MessageText.Format(GetResString(IDS_RECONNECT), CS_RETRYCONNECTTIME);
				theApp.smtpconnection->SendMail(MessageText, theApp.glob_prefs->GetNotifierPopOnServerError(), theApp.glob_prefs->IsSMTPWarningEnabled());
				theApp.emuledlg->ShowNotifier(MessageText, TBN_SERVER, false, theApp.glob_prefs->GetNotifierPopOnServerError());
				AddLogLine(false,IDS_RECONNECT, CS_RETRYCONNECTTIME); 
				m_idRetryTimer = SetTimer(NULL, 0, 1000*CS_RETRYCONNECTTIME, (TIMERPROC)RetryConnectCallback);
			}
			theApp.emuledlg->ShowConnectionState(false,_T(""),true);
			break;
		}
		case CS_DISCONNECTED:{
			connected = false;
			if (connectedsocket) 
				connectedsocket->Close();
			connectedsocket = NULL;
			theApp.emuledlg->searchwnd.OnBnClickedCancels();
			if (app_prefs->Reconnect() && !connecting){
				ConnectToAnyServer();		
			}
			// Purity - Sending message when connection lost
			CString MessageText;
			MessageText.Format(GetResString(IDS_CONNECTIONLOST));
			theApp.smtpconnection->SendMail(MessageText, theApp.glob_prefs->GetNotifierPopOnServerError(), theApp.glob_prefs->IsSMTPWarningEnabled());
			theApp.emuledlg->ShowNotifier(MessageText, TBN_SERVER, false, theApp.glob_prefs->GetNotifierPopOnServerError());
			theApp.emuledlg->ShowConnectionState(false,_T(""),true);
			break;
		}
		case CS_ERROR:
		case CS_NOTCONNECTED:{
			if (!connecting)
				break;
			AddLogLine(false,IDS_ERR_CONFAILED,sender->info, sender->cur_server->GetFullIP(), sender->cur_server->GetPort() );
		}
		case CS_SERVERDEAD:
		case CS_SERVERFULL:{
			if (!connecting)
				break;

			DWORD tmpkey;
			CServerSocket* tmpsock;
			POSITION pos = connectionattemps.GetStartPosition();
			while (pos){
				connectionattemps.GetNextAssoc(pos,tmpkey,tmpsock);
				if (tmpsock==sender) {
					connectionattemps.RemoveKey(tmpkey);
					break;
				}
			}			
			TryAnotherConnectionrequest();
		}
	}
	theApp.emuledlg->ShowConnectionState(false,_T(""),true);
	EMULE_CATCH
}

// 09/28/02, by zegzav
VOID CALLBACK CServerConnect::RetryConnectCallback(HWND hWnd, UINT nMsg, UINT nId, DWORD dwTime) 
{ 
	EMULE_TRY	//SyruS (0.29c) NOTE: Always handle all type of MFC exceptions in TimerProcs - otherwise we'll get mem leaks
	CServerConnect *_this= theApp.serverconnect; 
	ASSERT(_this); 
	_this->StopConnectionTry();
	if (_this->IsConnected()) return; 

	_this->ConnectToAnyServer();
	EMULE_CATCH
}


VOID CALLBACK CServerConnect::CheckInternetCallback(HWND hWnd, UINT nMsg, UINT nId, DWORD dwTime) 
{
	EMULE_TRY
	CServerConnect *_this= theApp.serverconnect; 
	ASSERT(_this); 

	KillTimer(NULL, _this->m_idCheckTimer);
	_this->m_idCheckTimer = 0;

	if(_this->IsConnected()) return;

	CString sUrl;
	sUrl.Format(_T("http://%s"), theApp.g_Urls[rand() % theApp.g_Urls.GetSize()]);

	CString message = GetResString(IDS_NET_CHECKING) + " [" + sUrl + "]";
	AddLogLine(false, message);

	if(_this->IsAliveURL(sUrl))
	{
		AddLogLine(false,IDS_NET_WORKING);
		_this->m_nConnectionAttempts = 0;
		if(!_this->IsConnecting())
			_this->ConnectToAnyServer(); 
	}
	else
	{
		_this->m_idCheckTimer = SetTimer(NULL, 0, 1000*CS_RETRYCONNECTTIME, (TIMERPROC)CheckInternetCallback);
		if(_this->IsConnecting())
			_this->StopConnectionTry();
	}
	EMULE_CATCH
}

bool CServerConnect::IsAliveURL(LPCTSTR sURL)
{
	EMULE_TRY
	HINTERNET hOpen = InternetOpen(_T(""), INTERNET_OPEN_TYPE_PRECONFIG , NULL, NULL, 0);
	if(!hOpen)
		return false;
 
	HINTERNET hUrl =  InternetOpenUrl(hOpen, sURL, _T(""), NULL, /*INTERNET_FLAG_NO_AUTH | */INTERNET_FLAG_NO_CACHE_WRITE, NULL);
	if(!hUrl)
	{
		InternetCloseHandle(hOpen);
		return false;
	}
 
	TCHAR szBuffer[100];
	DWORD dwBytes = 100;
	DWORD dwIndex = 0;
	BOOL bQ = HttpQueryInfo(hUrl, HTTP_QUERY_STATUS_CODE, szBuffer, &dwBytes, &dwIndex);

	bool bSuccess = bQ && !_tcscmp(szBuffer, _T("200"));

	InternetCloseHandle(hUrl);
	InternetCloseHandle(hOpen);
 
	return bSuccess;
	EMULE_CATCH
	return false;
}

void CServerConnect::CheckForTimeout()
{
	EMULE_TRY
	//SyruS (0,29c) DWORD maxage=GetTickCount() - CONSERVTIMEOUT;	// this gives us problems when TickCount < TIMEOUT (may occure right after system start)
	DWORD dwCurTick = GetTickCount();
	DWORD tmpkey;
	CServerSocket* tmpsock;
	POSITION pos = connectionattemps.GetStartPosition();
	while (pos){
		connectionattemps.GetNextAssoc(pos,tmpkey,tmpsock);
		if (!tmpsock) {
			AddDebugLogLine(false,_T("Error: Socket invalid at timeoutcheck") );
			connectionattemps.RemoveKey(tmpkey);
			return;
		}

		//SyruS (0,29c) if (tmpkey<=maxage) {
		if (dwCurTick - tmpkey > CONSERVTIMEOUT){
			AddLogLine(false,IDS_ERR_CONTIMEOUT,tmpsock->cur_server->GetListName(), tmpsock->cur_server->GetFullIP(), tmpsock->cur_server->GetPort() );
			connectionattemps.RemoveKey(tmpkey);
			TryAnotherConnectionrequest();
			//DestroySocket(tmpsock);	//eklmn: socket will be destroyed over TryAnotherConnectionrequest()
		}
	}
	EMULE_CATCH
}

bool CServerConnect::Disconnect()
{
	EMULE_TRY
	if ((connected || connecting) && connectedsocket){ // eklmn: bugfix(10): socket will be not destoyed if server is changed during connecting
		DestroySocket(connectedsocket);
		bool prevconnected= connected;
		connectedsocket = NULL;
		connected = false;
		connecting =false;	// eklmn: bugfix(10): socket will be not destoyed if server is changed during connecting
		theApp.emuledlg->ShowConnectionState(false,_T(""));
		theApp.emuledlg->serverwnd.servermsgbox.AppendText(CString("\n\n\n\n"));
		theApp.stat_serverConnectTime=0;
		if (prevconnected)
			theApp.emuledlg->sharedfileswnd.sharedfilesctrl.UpdateOfferedItems();	// refresh offered files
		return true;
	}
	EMULE_CATCH
	return false;
}

CServerConnect::CServerConnect(CServerList* in_serverlist, CPreferences* in_prefs)
{
	EMULE_TRY
	connectedsocket = NULL;
	app_prefs = in_prefs;
	used_list = in_serverlist;
	max_simcons = 1;
	connecting = false;
	connected = false;
	clientid = 0;
	udpsocket = new CUDPSocket(this); // initalize socket for udp packets
	udpsocket->Create();
	m_idRetryTimer= 0;
	lastStartAt=0;
	m_idCheckTimer = 0;
	m_nConnectionAttempts = 0;
	ConnectingToServer = NULL;
	InitLocalIP();
	EMULE_CATCH
}

CServerConnect::~CServerConnect()
{
	EMULE_TRY
	// stop all connections
	StopConnectionTry();
	// close connected socket, if any
	DestroySocket(connectedsocket);
	connectedsocket = NULL;
	// close udp socket
	udpsocket->Close();
	delete udpsocket;
	EMULE_CATCH
}

CServer* CServerConnect::GetCurrentServer()
{
	EMULE_TRY
	if (IsConnected() && connectedsocket)
		return connectedsocket->cur_server;
	EMULE_CATCH
	return NULL;
}

//purity (Server status in WebServer)
CServer* CServerConnect::GetConnectingServer()
{
	EMULE_TRY
	if (connecting && ConnectingToServer)
		return ConnectingToServer;
	EMULE_CATCH
	return NULL;
}

void CServerConnect::SetClientID(uint32 newid)
{
	EMULE_TRY
	clientid = newid;
	theApp.emuledlg->ShowConnectionState(IsConnected(),GetCurrentServer()->GetListName() );
	EMULE_CATCH
}

void CServerConnect::DestroySocket(CServerSocket* pSck)
{
	EMULE_TRY
	if (pSck == NULL)
		return;

	POSITION posDel = m_lstOpenSockets.Find(pSck);
	if (posDel != NULL) {
		m_lstOpenSockets.RemoveAt(posDel);		
	}
	
	if (pSck->m_SocketData.hSocket != INVALID_SOCKET){ // deadlake PROXYSUPPORT - changed to AsyncSocketEx
		pSck->AsyncSelect(0);
		pSck->Close();
	}

	delete pSck;
	
	EMULE_CATCH
}

bool CServerConnect::IsLocalServer(uint32 dwIP, uint16 nPort)
{
	EMULE_TRY
	if (IsConnected()){
		if (connectedsocket->cur_server->GetIP() == dwIP && connectedsocket->cur_server->GetPort() == nPort)
			return true;
	}
	EMULE_CATCH
	return false;
}

void CServerConnect::InitLocalIP()
{
	EMULE_TRY
	m_nLocalIP = 0;
	// Don't use 'gethostbyname(NULL)'. The winsock DLL may be replaced by a DLL from a third party
	// which is not fully compatible to the original winsock DLL. ppl reported crash with SCORSOCK.DLL
	// when using 'gethostbyname(NULL)'.
	char szHost[256];
	if (gethostname(szHost, sizeof szHost) == 0){
		hostent* pHostEnt = gethostbyname(szHost);
		if (pHostEnt != NULL && pHostEnt->h_length == 4 && pHostEnt->h_addr_list[0] != NULL)
			m_nLocalIP = *((uint32*)pHostEnt->h_addr_list[0]);
	}
	EMULE_CATCH
}

#endif //OLD_SOCKETS_ENABLED
